/**********************************************************************
***********************************************************************
Copyright 1995 by the Massachusetts Institute of Technology.  All 
rights reserved.

Developed by Bruce M. Blumberg at the Media Laboratory, MIT, Cambridge, 
Massachusetts, with support from Sega North America.

For use by Dan Weld, University of Washington.
  
This distribution is approved by Nicholas Negroponte, Director of 
the Media Laboratory, MIT.

Permission to use, copy, or modify this software and its documentation
for educational and research purposes only and without fee is hereby
granted, provided that this copyright notice and the original authors'
names appear on all copies and supporting documentation.  If individual 
files are separated from this distribution directory structure, this 
copyright notice must be included.  For any other uses of this software, 
in original or modified form, including but not limited to distribution 
in whole or in part, specific prior permission must be obtained from 
MIT.  These programs shall not be used, rewritten, or adapted as the 
basis of a commercial software or hardware product without first 
obtaining appropriate licenses from MIT.  MIT makes no representations 
about the suitability of this software for any purpose.  It is provided 
"as is" without express or implied warranty.
************************************************************************
************************************************************************/
// list.hh

#include <iostream.h>

#ifndef LIST_HH
#define LIST_HH

class Link
{
 public:
  Link *next;
  void *object;
  
  Link(void *obj) { next = 0; object = obj; }
  virtual ~Link() {delete next; }
};

class List
{
 public:
  Link *head, *tail;
  int length;
  
  List() {
    length = 0;
    head = tail = 0;
  }
  virtual ~List() {
    delete head; // this will delete every node
  }
  
  void add(void *obj) {
    if (head) {
      tail->next = new Link(obj);
      tail = tail->next;
      length++;
    }
    else {
      head = tail = new Link(obj);
      length = 1;
    }
  }
  
  Link *find(void *obj);
  
  void *remove(void *obj);
  
};

#endif
