#define SOUND_SERVER "/mas/vision/projects/ive/alive/Creature/SoundLib/SoundServer"

#include <iostream.h>
#include <string.h>
#include <strings.h>
#include <getopt.h>
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Xm.h>
#include <Inventor/SoDB.h>
#include <Inventor/SoInput.h>
#include <Inventor/nodekits/SoWrapperKit.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoGroup.h>
#include <Inventor/nodes/SoLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoSelection.h>
#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/elements/SoCacheElement.h>
#include <Inventor/sensors/SoSensor.h>
#include <Inventor/sensors/SoIdleSensor.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/events/SoLocation2Event.h>
#include <Inventor/nodes/SoEventCallback.h>
#include <Inventor/sensors/SoTimerSensor.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/manips/SoTransformBoxManip.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>

#include <Xm/Xm.h>
#include <Xm/PushB.h>

#include "AliveLib.h"
#include "CreatureLib.h"
#include "MotorLib.h"
//#include "PiggyLib.h"
#include "SensorLib.h"
#include "ActivityLib_1.h"
#include "BehaviorCreature.h"
#include "Car.h"
#include "Ball.h"
#include "BehaviorBall.h"
#include "Food.h"
#include "AliveDogLib_2.h"
#include "DogHouse.h"
#include "Bird.h"
//#include "TrackerLib.h"
#include "TextLib.h"
//#include "MotionCreatureLib.h"
//#include "LightLib.h"
#include "MediaLib.h"
#include "BehaviorBookLib.h"

extern void tclInit(int argc, char **argv);
extern void tclCB(void *data, SoSensor *sensor);
extern SoTransformBoxManip *tbm;

#include "globals.h"
Globals globals;
int runningInZoo = 0;
int tclActive = 0;
int chromakey;
int useSound;
extern int gestureText;
int continuousMode = 1;
int monitorTclFlag = 1;
char **global_argv;

/* Quick hack to turn on/off pfinder kalman filtering.
   Sorry -- kbrussel 8/2/95 */
extern int contourserver_use_kalman;

void
dragMoveCallback(
   void *data, // user data
   SoDragger *dragger)    // callback data not used
{
   printf("I got called \n");
}
 
void 
idleCB(void *theGlobals, SoSensor *sensor)
{
//    static Timestat *ts = NULL;
//    static Timestat *ss = new Timestat("cache time", 20);
//    if(ts)
//	ts->endTime();
    
    sensor->schedule();
/*    
    static SbTime *lastCalledAt = NULL;
    if(!lastCalledAt){
	lastCalledAt = new SbTime();
	lastCalledAt->setToTimeOfDay();
    }
    SbTime nt;
    nt.setToTimeOfDay();
    float dt = (float)((nt - *lastCalledAt).getValue());
    *lastCalledAt = nt;
*/    
//    ss->startTime();
    if(monitorTclFlag)
	tclCB(NULL, sensor);
    if(continuousMode == 1)
	globals.creatureCache->updateStateAt(.1);

// added by aries
     SoundSkill::updateSoundsFixedView();

//    ss->endTime();
//    if(!ts)
//	ts = new Timestat("cycletime ", 20);
//    ts->startTime();
}

void loadCreatures()
{
    globals.creatureCache->addBaseCreatureFromFile("alive/wall.iv");
    globals.creatureCache->addBaseCreatureFromFile("alive/kbperson.iv");
    globals.creatureCache->addBaseCreatureFromFile("alive/alivedog.iv");
    globals.creatureCache->addBaseCreatureFromFile("alive/ball1.iv");
    globals.creatureCache->addBaseCreatureFromFile("alive/hydrant.iv");
    globals.creatureCache->addBaseCreatureFromFile("alive/d1.iv");
}

main(int argc, char **argv)
{

  /* Args.  They may come in any order.  Those which are groups in this listing
   are supposed to be mutually exclusive, though at the moment, we don't check,
   and the one you get will be arbitrary.  Note that they are CASE SENSITIVE.
   They must all be the first arg (e.g., "Hamsterdam pstg7").  Unrecognized
   characters are ignored.  Yes, this argument parsing _still_ sucks, but it's
   still better than the predecessors.

   h			use shadow
   t			tcl active
   c			Chromakey blending
   v			vision (connection to backsub requested)
   g			gestureText
   r			do partial restart
   z			run in zoo
   s			use sound
   d			Distributed ALIVE (defaults to server)
   n <server name>	dALIVE client: connect to server <server name>
   u                    minimum rendering rate (in hertz)
   k                    turn off pfinder kalman filtering

   Example of running Distributed ALIVE:
   edgware% AliveApp -d -t
   vauxhall% AliveApp -t -n edgware
   */

    global_argv = argv;	    /* For auto-restart. */
    int i;		    /* Only for use in arg parsing; value not used. */ 
    char *alive_server_name = NULL;
    
    while ((i = getopt(argc, argv, "cghvrtzsdku:n:")) != EOF) 
      {
	switch(i)
	  {
	  case 'c':
	    Alive::chromakey = 1;
	    break;

	  case 'g':
	    Alive::gestureText = 1;
	    break;
	    
	  case 'h':
	    Alive::useShadow = 1;
	    break;

	  case 'v':
	    Alive::connectToVision = 1;
	    break;
	    
	  case 'r':
	    Alive::doPartialRestart = 1;
	    break;
	    
	  case 't':
	    tclActive = 1;
	    break;
	    
	  case 'z':
	    runningInZoo = 1;
	    break;
	    
	  case 's':
	    useSound = 1;
	    break;
	    
	  case 'd':
	    Alive::isDistributed = 1;
	    Alive::doPartialRestart = 1;
	    break;
	    
	  case 'n':
	    Alive::isDistributed = 1;
	    Alive::iAmServer = 0;
	    Alive::doPartialRestart = 1;  /* Don't do an execv during Distributed ALIVE!
					     Actually this will only cause problems for
					     the Alive Server (and will require a reboot
					     to fix the machine), but set this in both
					     the client and server nonetheless. */
	    alive_server_name = optarg;
	    break;

	  case 'u':
	    Alive::maxTimeBetweenRenders = 1.0 / (float) atoi(optarg);
	    break;

	  case 'k':
	    contourserver_use_kalman = 0;
	    break;

	  default:
	    cerr << "Unrecognized option: " << (char) i << endl;
	    break;
	  }
      }

    /* hack for ContourServer which doesn't know about Alive */
    chromakey = Alive::chromakey;
    gestureText = Alive::gestureText;

    //
    // Initialize Inventor and Xt
    //
    Widget myWindow = SoXt::init(argv[0]);
    if (myWindow == NULL) exit(1);
    
    //
    // Initialize the new node classes
    //
    CreatureLibInit();
    MotorLibInit();
    SensorLibInit();
    Dog::initClass();
    Car::initClass();
    Ball::initClass();
    initActivityClasses();
    BehaviorCreatureLibInit();
    BehaviorBall::initClass();
    DogHouse::initClass();
    Food::initClass();
    Bird::initClass();
    AliveDogLib_2Init();
    AliveLibInit();
    Text::initClass();
//    MotionCreature::initClass();
    MediaLibInit();
    BehaviorBookLibInit();
    
    Alive *aliveController;
    if(!runningInZoo){
	if (getenv("PFINDER_HOST")) {
	      Alive::visionServerName = getenv("PFINDER_HOST");
	} else {
	      Alive::visionServerName = "blackfriars";
	}
	char *cp;
	if (getenv("ALIVE_CAMERA_PARAMS")) {
	      cp = getenv("ALIVE_CAMERA_PARAMS");
	} else {
	      cp = "cameraParameters";
	}
	aliveController= new Alive(myWindow, cp,
	"gesture_parameters.dat", alive_server_name);
    }
    else {
	Alive::visionServerName = "dawkins";
	aliveController = new Alive(myWindow, "zooCameraParameters", 
	"gesture_parameters.dat", alive_server_name);
    }
    
    if (useSound)
      {
	char buf[256];
	if (getenv("SOUND_HOST"))
	  {
	    sprintf(buf, "rsh %s %s", getenv("SOUND_HOST"), SOUND_SERVER);
	    SoundSkill::connectToServer(buf);
	    SoundSkill::setSpeakerPositions(67.2, 76.8);
	    if (!SoundSkill::isServerConnected())
	      {
		fprintf(stderr, "Connection to sound server %s failed\n",
			getenv("SOUND_HOST"));
		useSound = 0;
	      }
	    else
	      {
		printf("Connected to sound server\n");
	      }
	  }
	else
	  {
	    fprintf(stderr, "To use sound output, please set environment variable SOUND_HOST to the machine to run sound on, and make sure you have a .rhosts entry on SOUND_HOST for the machine running ALIVE.  Sound Disabled.\n");
	  }
      }
    
    globals.Viewer = aliveController->currentViewer;
    globals.creatureCache = aliveController->creatureCache;
    if(tbm){
	tbm->getDragger()->addMotionCallback(dragMoveCallback, NULL);
    }
    //
    // Init things and globals
    //
    globals.root = aliveController->root;
    globals.screen_width = 640;
    globals.screen_height = 480;
    globals.geomSep = aliveController->cacheRoot;
    
    //
    //  Idle Sensor for call back to tcl
    //
    if(tclActive){
	tclInit(argc, argv);
    }
    else {
	loadCreatures();
    }
    SoIdleSensor *is = new SoIdleSensor(idleCB, (void *)&globals);
    is->schedule();
    
//    SoTimerSensor *mySensor = new SoTimerSensor( idleCB, (void *)&globals );
//    mySensor->schedule();
    
    //
    // Create the window and enter the main loop
    //
    globals.Viewer->setTitle("AliveApp");
    globals.Viewer->show();
   // globals.Viewer->setPopupMenuEnabled(TRUE);
    
    SoXt::show(myWindow);
    XtMoveWidget(myWindow, 6, 0);
    SoXt::mainLoop();
}




