#include "AliveDog.h"
#include "BaseBehaviorNode.h"
#include "BehaviorCreatureLib.h"
#include "SensorLib.h"
#include "dogRMCallbacks.h"
#include "util.h" // macros defined in file live here

/*
 * Function types:
 *	typedef SbBool (*rmFilterCB)(ReleasingMechanism *rm, 
 *	    BehaviorUpdateAction *action);
 *	typedef float (*rmWeightCB)(ReleasingMechanism *rm, 
 *	    BehaviorUpdateAction *action);
 *	typedef void (*activityCB)(BaseActivity *act, 
 *	    BehaviorUpdateAction *action);
 *
 * Use these to add callbacks:
 *	addCallback(const char *name, rmFilterCB func);
 *	
 */

float weightByDistFromHips(ReleasingMechanism *rm, BehaviorUpdateAction *action)
{
    CBUA(dua, action);
    CRM(dogRM, rm);
    PRONOME_RM(p, rm);
    PFSENSOR(s, dua);
    SbVec3f ptNearBack(-20, 0, 0);
    ptNearBack = s->getVecInWorldFrame(ptNearBack);
    float r = (p->location - ptNearBack).length();
    float w = rm->calcWeightBasedOnRange(r);
    return (w * ((dogRM->maxValue.getValue() - dogRM->minValue.getValue())))+
	dogRM->minValue.getValue();
}

SbBool ballInMouthCB(ReleasingMechanism *rm, BehaviorUpdateAction *action)
{
     	CBUA(dua, action);
	CRM(dogRM, rm);
    	PRONOME_RM(p, rm);
	BaseCreature *bb = (BaseCreature *)p->object;
	if(bb->isGrabbed.getValue() && bb->grabbedBy == dua->creature)
	    return TRUE;
	else
	    return FALSE;
}

void aries(BaseActivity *ba, BehaviorUpdateAction *action)
{
    printf(" leaf is being call \n");
}
void initDogCallbackList()
{
    BaseBehaviorNode::addCallback("weightByDistFromHips", weightByDistFromHips);
    BaseBehaviorNode::addCallback("aries", aries);
    BaseBehaviorNode::addCallback("ballInMouth", ballInMouthCB);
}
