#ifndef ALIVECONTROLLER
#define ALIVECONTROLLER

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/manips/SoHandleBoxManip.h>
#include <Inventor/nodes/SoSelection.h>
#include "CreatureLib.h"

class SoSeparator;
class SoXtExaminerViewer;
class AliveCamera;
class VisionServices;

class Alive{
    // static variables
    public:
    static float Alive::worldExpireTime;
    static int Alive::chromakey;
    static int Alive::gestureText;
    static int Alive::useShadow;
    static int Alive::connectToVision;
    static char *Alive::visionServerName;
    static int Alive::shouldRestart;
    static int Alive::doPartialRestart;
    static VisionServices *Alive::visionServices;
    static AliveCamera *Alive::aliveCamera;
    static Alive *Alive::globalAlive;
    static int Alive::isDistributed;
    static int Alive::iAmServer;
    static float Alive::maxTimeBetweenRenders;
    
    // instance variables
    CreatureCache *creatureCache;
    SoXtExaminerViewer *currentViewer;
    SoSeparator *root;
    SoSeparator *cacheRoot;
    
    Alive::Alive(Widget appWindow, char *camParamFile,  char *gestFile, char *aliveServerName);
    
    void aliveInitialization(Widget myWindow, char *camParamFile,  char *gestFile);
    void cleanupAndRestart();
    
};

void cleanup(...);

#endif
