#include "AudioMan.h"
#include "AudioEvent.h"
#include "SocketMan.h"
#include <unistd.h>
#include <bstring.h>
int TICK = 100;

AudioMan::AudioMan (int port,
		    int use_udp)
{
  lastEventHandled = 1;
  ret = new AudioManRet;
  ret->utterance = (char *) malloc(sizeof(char)*100);
  
  sm = new SocketMan(port);
  sm->setQuiet(1);

  if (sm->acceptConnectionWithPoll()==0) {
    printf("got here...\n");
    hark_connection = 0;
    sm->rewindSockets();
    sm->nextSocket();
    printf("Connection accepted...trying to handshake\n");
    Handshake();
  }
}

AudioMan::~AudioMan()
{
  delete sm;
  delete ret->utterance;
  delete ret;
}

void AudioMan::CheckSpeech()
{
  SocketBuf *sbuf;
  AudioEvent *currAE;
  if ((sm->getNumberOfConnections() == 1) && (hark_connection==1)) {
    // i.e., if hand shaken already
    // NOTE: readWithPollAndTimeout allocates a new buf, so delete it!
    if ((sbuf = sm->readWithPollAndTimeout()) != NULL) {
      if (strcmp((char *)sbuf->buf,"Hark") != 0) {
	/*	printf("Strcmp = %d, Received %s\n", strcmp((char *)sbuf->buf,
			       		       "Hark"), 
	       (char *) sbuf->buf); 
	       */
	// cast it to an AE
	currAE = (AudioEvent *) sbuf->buf;
	// copy it over to the final location
	bcopy(currAE, &lastEvent, sizeof(AudioEvent));
	// delete the buffer
	delete sbuf;
	

	printf("Type %d AudioEvent Received: %s\n", currAE->event_type,
	       currAE->utterance);

	// mark as new event
	lastEventHandled = 0;

        (ret->tick) = TICK;
	printf("tick assigned\n");
	fflush(NULL);
      } else {

	return;
      }
    } else { 	
      if (sm->getGlobalMessage() == SocketBase::ERR_CURRENT_SOCKET_CLOSED)
	{
	  printf("Connection to HarkMan closed\n");
	  hark_connection = 0;
	}
      return;
    }
  }
  else {
    
    /* The connection has been made, but no handshake has been done */
    if ((hark_connection == 0) && (sm->getNumberOfConnections() == 1)) {
      Handshake();
    }
    else {
      if (sm->acceptConnectionWithPoll()==0) {
	hark_connection = 0;
	sm->rewindSockets();
	sm->nextSocket();
        printf("Connection accepted...trying to handshake\n");
        Handshake();
      }
    }
    return;
  }
}


AudioEvent* AudioMan::GetLastAudioEvent()
{
 if (lastEventHandled == 0) {
   lastEventHandled = 1;
   return(&lastEvent);
 }
 else {
   return((AudioEvent *) NULL);
 }
}


void
 AudioMan::Handshake()
{
  SocketBuf *sbuf;
  if ((sbuf = sm->readWithPollAndTimeout()) != NULL)  {
    if (strcmp((char *)sbuf->buf,"Hark") == 0) {
      hark_connection=1;
      printf("Hand Shaken!!\n");
      /* sbuf->buf = "Accepted";
	 sm->writeWithTimeout(sbuf);
	 */
    }
    else {
      printf("Received %s before Handshake\n",(char*) sbuf->buf);
    }
  }
}




