#include "AvatarRep.h"
#include "BaseCreature.h"
#include "BehaviorPerson.h"
#include <Inventor/nodes/SoScale.h>
#include <Inventor/fields/SoSFString.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/elements/SoElements.h>
#include <Inventor/elements/SoSwitchElement.h>
#include "Avatar.h"

SO_NODE_SOURCE(AvatarRep);

void
AvatarRep::initClass()
{
    SO_NODE_INIT_CLASS(AvatarRep, RepContainer, "RepContainer");
}

AvatarRep::AvatarRep() : RepContainer()
{
    SO_NODE_CONSTRUCTOR(AvatarRep);

    SO_NODE_ADD_FIELD(avatarfilename, ("av.iv"));
}

AvatarRep::~AvatarRep()
{
}

SbBool
#ifdef SO_VERSION_REVISION
AvatarRep::readInstance(SoInput *in, unsigned short flags)
#else
AvatarRep::readInstance(SoInput *in)
#endif
{
#ifdef SO_VERSION_REVISION
    if (RepContainer::readInstance(in, flags)) {
#else
    if (RepContainer::readInstance(in)) {
#endif
          SoInput ain;
	  if (ain.openFile(avatarfilename.getValue().getString()) == TRUE) {
		avatar = (Avatar *) SoDB::readAll(&ain);
		addChild(avatar);
		puts("read in avatar!");
		return (1);
	  } else {
		fprintf(stderr, "AvatarRep: can't read %s!\n",avatarfilename.getValue().getString());
		return (0);
	  }
    }
    return (0);
}

void AvatarRep::updateStateAt(BaseCreature *bc, UpdateStateData &usd)
{
    //
    //	Add your code here
    //

    if (bc->isOfType(BehaviorPerson::getClassTypeId())) {
	  BehaviorPerson *bp = (BehaviorPerson *) bc;

	  if (bp->personExists.getValue() == TRUE) {
	  	avatar->updateToNewPositions(bp->normalHeight.getValue(),
					     bp->leftHand.getValue(),
					     bp->rightHand.getValue(),
					     bp->head.getValue(),
				   	     bp->bodyCentroid.getValue());
	  }
    } else {
	  fprintf(stderr, "AvatarRep: UpdateStateAt: Called on non-Behavior Person!\n");
    }

    return;
}

SO_NODE_SOURCE(GeomRep);

void
GeomRep::initClass()
{
    SO_NODE_INIT_CLASS(GeomRep, RepContainer, "RepContainer");
}

GeomRep::GeomRep() : RepContainer()
{
    SO_NODE_CONSTRUCTOR(GeomRep);
}

GeomRep::~GeomRep()
{
}

SbBool
#ifdef SO_VERSION_REVISION
GeomRep::readInstance(SoInput *in, unsigned short flags)
#else
GeomRep::readInstance(SoInput *in)
#endif
{
#ifdef SO_VERSION_REVISION
    if (RepContainer::readInstance(in, flags)){
#else
    if (RepContainer::readInstance(in)){
#endif
	return (1);
    }
    return (0);
}

void GeomRep::updateStateAt(BaseCreature *bc, UpdateStateData &usd)
{
    //
    //	Add your code here
    //
    printf("I got called \n");
    return;
}
