#ifndef _AVATARREP_
#define _AVATARREP_
/*********************************************************************
 * 
 * 
 * 
 ********************************************************************/
#include <Inventor/SbBasic.h>
#include <Inventor/SoInput.h>
#include <Inventor/actions/SoAction.h>
#include <Inventor/actions/SoGLRenderAction.h>
#include <Inventor/fields/SoSFEnum.h>
#include <Inventor/fields/SoMFVec2f.h>
#include <Inventor/fields/SoMFInt32.h>
#include <Inventor/fields/SoSFString.h>
#include <Inventor/nodes/SoSwitch.h>
#include <Inventor/sensors/SoFieldSensor.h>
#include <Inventor/actions/SoSubAction.h>
#include <Inventor/fields/SoSFEnum.h>
#include <Inventor/fields/SoMFEnum.h>
#include "../CreatureLib/CreatureCache.h"
#include "../CreatureLib/RepSwitch.h"
#include <Inventor/SoPath.h>

/* These 2 classes are stubs for the AvatarReps and GeomReps. They are
 * subclasses of RepContainer which is defined in RepSwitch.[hc++] in
 * CreatureLib. MotorCreatures (the parent of BehaviorCreature which
 * is the parent of BehaviorPerson) are set up so that if their updateReps
 * field is TRUE (and by default it is FALSE) then after the MotorSkills
 * have finished updating themselves,  the updateRepsAt() method of BaseCreature
 * is called and it iterates through its repList (built as the creature is read
 * in) and calls the updateStateAt() method of RepSwitch. This method in
 * turn calls the updateStateAt() method of whatever rep is currently its
 * active rep. SO... theoretically all you have to do is add code to the
 * updateStateAt methods below. The first arg to updateStateAt() is a pointer
 * to the creature and the second arg contains lots of useful stuff. It
 * is defined in CreatureCache.h in CreatureLib.
 * 
 * See RepSwitch.h in CreatureLib for more info
 */
class Avatar;
    
class AvatarRep : public RepContainer {

    SO_NODE_HEADER(AvatarRep);

public:
    SoSFString avatarfilename;
    AvatarRep();
    Avatar *avatar;
    static void initClass();
    virtual void updateStateAt(BaseCreature *parent,UpdateStateData &usd);
    protected:
    virtual ~AvatarRep();
#ifdef SO_VERSION_REVISION
    SbBool readInstance(SoInput *in, unsigned short flags);
#else
    SbBool readInstance(SoInput *in);
#endif
};

class GeomRep : public RepContainer {

    SO_NODE_HEADER(GeomRep);

public:
    GeomRep();
    static void initClass();
    virtual void updateStateAt(BaseCreature *parent,UpdateStateData &usd);
    protected:
    virtual ~GeomRep();
#ifdef SO_VERSION_REVISION
    SbBool readInstance(SoInput *in, unsigned short flags);
#else
    SbBool readInstance(SoInput *in);
#endif
};

#endif
