#include <GL/gl.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoBaseColor.h>
#include <Inventor/nodes/SoCallback.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoMatrixTransform.h>
#include <Inventor/actions/SoGLRenderAction.h>
#include "Shadow.h"
#include <stdio.h>
int ShadowNode::shadowPass = 0;
SoMatrixTransform *xmt;
extern int chromakey;

void preShadow(void *ud, SoAction *action)
{
    static int ft= 1;
    ShadowNode *sn = (ShadowNode *)ud;
    GLint param;
    
    if(action->isOfType(SoGLRenderAction::getClassTypeId())){
	//glPushMatrix();
	ShadowNode::shadowPass = 1;
	sn->shadmat->setOverride(TRUE);
	//sn->shadowMatrix();
	//sn->grabNodePre->touch();
    }
}

void postShadow(void *ud, SoAction *action)
{
    static int ft= 1;
    ShadowNode *sn = (ShadowNode *)ud;
    GLint param;
    
    if(action->isOfType(SoGLRenderAction::getClassTypeId())){
	//glPopMatrix();
	ShadowNode::shadowPass = 0;
	sn->shadmat->setOverride(FALSE);
	//sn->grabNodePost->touch();
    }
}

ShadowNode::ShadowNode(SbVec3f dir, SbVec4f plane, SoSeparator *scene)
{
    dir.getValue(d[0],d[1], d[2]);
    plane.getValue(p[0],p[1], p[2], p[3]); 
    sep = new SoSeparator;
    xmt = new SoMatrixTransform;
    shadowMatrix();
    sep->addChild(scene);
    grabNodePre = new SoCallback;
    grabNodePre->setCallback(preShadow,this);
    sep->addChild(grabNodePre);
    sep->addChild(xmt);
    shadmat = new SoMaterial;
    shadmat->diffuseColor.setValue(SbColor(0, 0, 0));
    if(!chromakey)
	shadmat->transparency.setValue(.45);
    sep->addChild(shadmat);
    sep->addChild(scene);
    grabNodePost = new SoCallback;
    grabNodePost->setCallback(postShadow,this);
    sep->addChild(grabNodePost);
}

void ShadowNode::shadowMatrix()
{
    GLfloat m[16];
    int i, j;
    
    for(i=0;i<4;i++){
	for(j=0;j<3;j++){
	    m[i*4+j] = p[i]*d[j];
	}
	m[j] = 0;
    }
    m[0] = -(p[1]*d[1] + p[2]*d[2]);
    m[5] = -(p[0]*d[0] + p[2]*d[2]);
    m[10] = -(p[1]*d[1] + p[0]*d[0]);
    m[15] = -(p[0]*d[0] + p[1]*d[1] +  p[2]*d[2]);
    SbMatrix sbm(
	m[0],m[1],m[2],m[3],
	m[4],m[5],m[6],m[7],
	m[8],m[9],m[10],m[11],
	m[12],m[13],m[14],m[15]);
    xmt->matrix.setValue(sbm); 
    //glMultMatrixf(m);   
}


