#ifndef TEXTANNOTATION
#define TEXTANNOTATION
//===========================================================================
// TextAnnonation.h
//===========================================================================

#include <X11/Intrinsic.h>
#include <Inventor/Sb.h>
#include <Inventor/SoInput.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoPickStyle.h>
#include <Inventor/nodes/SoSelection.h>
#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoText2.h>
#include <Inventor/nodes/SoTransform.h>
#include "common.h"
#include "ring_buffer.h"
#include "user_model.h"

class TextAnnotation {
public:
  //============================================================
  // member variables
  //============================================================
  //------------------------------------------------------------
  // Materials for the Puppet Text Annotation
  //------------------------------------------------------------
  //----------------------------------------
  // General
  //----------------------------------------
  SoMaterial *material_center;
  SoMaterial *material_standing;
  SoMaterial *material_sitting;
  SoMaterial *material_hand_over_head;
  SoMaterial *material_bending;
  SoMaterial *material_user_exists;
  //----------------------------------------
  // Left
  //----------------------------------------
  SoMaterial *material_left;
  SoMaterial *material_left_pointing;
  SoMaterial *material_left_kicking;
  SoMaterial *material_left_waving;
  SoMaterial *material_left_throwing;
  SoMaterial *material_left_extending;
  SoMaterial *material_left_hand_moving;
  //----------------------------------------
  // Right
  //----------------------------------------
  SoMaterial *material_right;
  SoMaterial *material_right_pointing;
  SoMaterial *material_right_kicking;
  SoMaterial *material_right_waving;
  SoMaterial *material_right_throwing;
  SoMaterial *material_right_extending;
  SoMaterial *material_right_hand_moving;
  //============================================================
  // member functions
  //============================================================
  TextAnnotation();
  SoSeparator *makeText(const SbVec3f &textPosition, 
			SoMaterial *materialPointer, 
			const SbColor &textColor,
			const SoText2::Justification &textJustification,
			char *actualText);
  SoSeparator *createTextSetup();
  void updateText(GestureFlags *gesture);
};

#endif
