#include <Inventor/nodes/SoGroup.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoFont.h>
#include <Inventor/nodes/SoText2.h>
#include <Inventor/nodes/SoTransform.h>

#include "TextGauge.h"

TextGauge::TextGauge()
{
   root = new SoSeparator;
   
   // add transform
   root->addChild(new SoTransform);
   
    // Let's make the text green
   SoMaterial *material = new SoMaterial;
   material->diffuseColor.setValue(1, 0, 0);
   root->addChild(material);

   // Choose a font likely to exist.
   SoFont *font = new SoFont;
   font->name.setValue("Times-Roman");
   font->size.setValue(12.0);
   root->addChild(font);

   // Add the text
   SoText2 *text = new SoText2;
   text->string.setValue("hello world");
   text->justification.setValue(SoText2::LEFT);
   root->addChild(text);
}

void TextGauge::moveTextTo(SbVec3f np)
{
   SoTransform *xf = (SoTransform *)root->getChild(0);
   xf->translation.setValue(np); 
}

void TextGauge::setValue(char *s)
{
   SoText2 *t = (SoText2 *)root->getChild(3);
   t->string.setValue(s); 
}

void TextGauge::set1Value(int i, char *s)
{
   SoText2 *t = (SoText2 *)root->getChild(3);
   t->string.set1Value(i, s); 
}

void TextGauge::setLineSpacing(float ns)
{
   SoText2 *t = (SoText2 *)root->getChild(3);
   t->spacing.setValue(ns); 
}

void TextGauge::setSize(float ns)
{
   SoFont *f = (SoFont *)root->getChild(2);
   f->size.setValue(ns); 
}

void TextGauge::setColor(SbColor color)
{
   SoMaterial *t = (SoMaterial *)root->getChild(1);
   t->diffuseColor.setValue(color); 
}

void TextGauge::displayTitleAndFloats(char *s, int c, float *vals)
{
    char buf[100];
    int i,sl;
    
    sprintf(buf, "%s", s);
    for(i =0 ;i<c;i++){
	sl = strlen(buf);
	sprintf(&buf[sl], " %f ", vals[i]);
    }
    setValue(buf);   
}
