#include "ContourServer.h"
#include "TextAnnotation.h"
#include "AliveCamera.h"
class AliveCamera;
class SoSeparator;

class VisionServices {
    public:
    static ContourServer *contourServer;
    static Gesture *gesture;
    static char *gesture_parameter_filename;
    AliveCamera *currentMapping;
    GestureFlags desired;
    GestureFlags found;
    //--------------------------------------------------
    // johnny's text annotation
    TextAnnotation *texta;
    
    /* connection made in constructor */
    VisionServices(char *machine, char *paramFile, SoSeparator *sep,
	AliveCamera *aMapping, int layers);
    
    /* use this to attach a new mapping */
    void setCurrentMapping(AliveCamera *aMapping);
    
    /* use this to insert the contour into a scene */
    void attachContourToSceneGraph(SoSeparator *sep);
    
    /* use this to read a contour and do gesture stuff */
    void updateStateAt();
    
    /* use these to open and close connnection */
    void openConnection();
    void closeConnection();

    /* these preempt closeConnection above and provide
       new functionality for resetting the worlds */
    void resetConnection();
    void abortConnection();
    
};
