#include <math.h>
#include <Inventor/SbLinear.h>
#include <Inventor/Sb.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoDB.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/engines/SoElapsedTime.h>
#include <Inventor/engines/SoTimeCounter.h>
#include <Inventor/engines/SoInterpolate.h>
#include <Inventor/engines/SoCalculator.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoPendulum.h>
#include <Inventor/nodes/SoShuttle.h>
#include "Ball.h"
#include "BallMotorSkills.h"
#include "CreatureLib.h"
#include "MotorLib.h"
#include "../MotorLib/BasicDefines.h"

SO_NODE_SOURCE(Ball);

void
Ball::initClass()
{
    SO_NODE_INIT_CLASS(Ball, MotorCreature, "MotorCreature");
}

Ball::Ball() : MotorCreature()
{
    SO_NODE_CONSTRUCTOR(Ball);
    SO_NODE_ADD_FIELD(restitution, (1.0));
    SO_NODE_ADD_FIELD(hasBeenThrown, (FALSE));
}

SbBool	
#ifdef SO_VERSION_REVISION
Ball::readInstance(SoInput *in, unsigned short flags) 
#else
Ball::readInstance(SoInput *in) 
#endif
{
#ifdef SO_VERSION_REVISION
   if (MotorCreature::readInstance(in, flags)) {
#else
   if (MotorCreature::readInstance(in)) {
#endif

	return(1);
   } else {
	return(0);
   }
}


Ball::~Ball()
{
}

void Ball::addMotorSkills()
{
    MotorCreature::addMotorSkills();

    BallMove *move = new BallMove(this, "move");
    getController()->addCommand( GC_MOVE_GEN, "move", move, 1, ArgType((float)0), ArgType((float)0), ArgType((float)0));

}
    
int Ball::stepTo(UpdateStateData &usd)
{
    if(isGrabbed.getValue() == TRUE){
	vel.v0 = SbVec3f(0, 0, 0);
	return 1;
    }
    else{
	SbVec3f p;
	getPosition(p);
	p += vel.v0*usd.time;
	setPosition(p);
	return 1;
    }
}











