#ifndef _BALLDEF_
#define _BALLDEF_

#include <Inventor/SbBasic.h>
#include <Inventor/SbPList.h>
#include "MotorCreature.h"

class GenericController;
class SoInput;
class SoCamera;
class BallController;

class Ball : public MotorCreature {
    SO_NODE_HEADER(Ball);

public:
    static void initClass();
    /* over-rides of methods defined in MotorCreature */
    SoSFFloat restitution;
    SoSFBool hasBeenThrown;
    virtual void addMotorSkills();
    virtual int stepTo(UpdateStateData &usd);


protected:
    Ball();           // Note only should be called during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool	readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool	readInstance(SoInput *in);
#endif
    virtual ~Ball();
    
}; 

#endif
