#ifndef BALLSKILLS
#define BALLSKILLS

#include "MotorSkill.h"
#include "Ball.h"

/**********************************************************************
 *
 * BallMove
 *
 * This MotorSkill implements moving in what ever direction the wheels are
 * pointing.
 *
 *  args (optional):
 *    0 - horizontal speed
 *    1 - vertical speed
 *    2 - restitution (0 to 1)
 **********************************************************************/

class BallMove: public MotorSkill {
  public:
    BallMove(Ball *p, char *pname);
    float restitution;
    int prepareToTurnOff(void *arg);
    int prepareToRun(void *arg);
    void updateStateAt(UpdateStateData &usd);
    int modifyRun(void *args);
};

class BallChangeColor: public MotorSkill {
  public:
    BallChangeColor(Ball *p, char *pname);
    void updateImmediate(void *arg);
};

class BallChangeAlpha: public MotorSkill {
  public:
    float target;
    BallChangeAlpha(Ball *p, char *pname);
    int prepareToRun(void *arg);
    int prepareToTurnOff(void *arg);
    virtual void updateStateAt(UpdateStateData &usd);
};

#endif











