#ifndef _BEHBALLDEF_
#define _BEHBALLDEF_

#include <Inventor/SbBasic.h>
#include <Inventor/SbPList.h>
#include "BehaviorCreature.h"

class GenericController;
class SoInput;
class SoCamera;

class BehaviorBall : public BehaviorCreature {
    SO_NODE_HEADER(BehaviorBall);

public:
    static void initClass();
    /* over-rides of methods defined in BehaviorCreature */
    SoSFFloat restitution;
    SoSFBool hasBeenThrown;
    SoSFVec3f homePosition;
    SoSFBool shouldReturnToHomePosition;
    
    int pickedUpByDog;
    virtual void addMotorSkills();
    virtual int stepTo(UpdateStateData &usd);
    virtual void getDOFInterpolators();

protected:
    BehaviorBall();           // Note only should be called during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool	readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool	readInstance(SoInput *in);
#endif
    virtual ~BehaviorBall();
    
}; 

#endif
