#ifndef _BEHBIRDDEF_
#define _BEHBIRDDEF_

#include <Inventor/SbBasic.h>
#include <Inventor/SbPList.h>
#include "BehaviorCreature.h"

class GenericController;
class SoInput;
class SoCamera;

class Bird : public BehaviorCreature {
    SO_NODE_HEADER(Bird);

public:
    static void initClass();
    /* over-rides of methods defined in BehaviorCreature */
    SoSFVec3f target;
    float vspeed;
    int nextRep;
    SoSFBool isMad;
    MotorCreature *grabber;
    virtual void addMotorSkills();
    virtual void getDOFInterpolators();
    virtual int stepTo(UpdateStateData &usd);
protected:
    Bird();           // Note only should be called during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool	readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool	readInstance(SoInput *in);
#endif
    virtual ~Bird();
    
}; 

class GenericClimb: public MotorSkill {
  public:
    float desired_speed;
    float start_speed;
    float time_since;
    float secs_to_reach;

    GenericClimb(MotorCreature *p, char *pname);

    int prepareToTurnOff(void *arg);
    int prepareToRun(void *arg);
    void updateStateAt(UpdateStateData &usd);
    int modifyRun(void *args);
    bool_t toOrFromStream(XDR *xdrs);
};

class BirdChangeColor: public MotorSkill {
  public:
    BirdChangeColor(Bird *p, char *pname);
    void updateImmediate(void *arg);
};
#endif
