#include <math.h>
#include <Inventor/SbLinear.h>
#include <Inventor/Sb.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoDB.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/nodes/SoBaseColor.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/engines/SoElapsedTime.h>
#include <Inventor/engines/SoTimeCounter.h>
#include <Inventor/engines/SoInterpolate.h>
#include <Inventor/engines/SoCalculator.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoPendulum.h>
#include <Inventor/nodes/SoShuttle.h>
#include <Inventor/nodes/SoMaterial.h>
#include "Food.h"
#include "BallMotorSkills.h"
#include "CreatureLib.h"
#include "MotorLib.h"
#include "AliveDogLib_2.h"
#include "BehaviorCreatureLib.h"
#include "../BehaviorCreatureLib/util.h"
#include "../MotorLib/BasicDefines.h"

SO_NODE_SOURCE(Food);

void
Food::initClass()
{
    SO_NODE_INIT_CLASS(Food, BehaviorCreature, "BehaviorCreature");
}

Food::Food() : BehaviorCreature()
{
    SO_NODE_CONSTRUCTOR(Food);
    SO_NODE_ADD_FIELD(value, (0));
}

SbBool	
#ifdef SO_VERSION_REVISION
Food::readInstance(SoInput *in, unsigned short flags) 
#else
Food::readInstance(SoInput *in) 
#endif
{
#ifdef SO_VERSION_REVISION
   if (BehaviorCreature::readInstance(in, flags)) {
#else
   if (BehaviorCreature::readInstance(in)) {
#endif

	return(1);
   } else {
	return(0);
   }
}


Food::~Food()
{
}

void Food::addMotorSkills()
{
    BehaviorCreature::addMotorSkills();
}

void Food::getDOFInterpolators()
{
}
    
