#ifndef _BEHCREATURE_DEF
#define _BEHCREATURE_DEF

#include <Inventor/SbPList.h>
#include "CreatureBehavior.h"
#include "MotorLib.h"
#include <Inventor/fields/SoSFString.h>

class SniffSensor;
class AliveRaySensor;
class PotentialFieldSensor;
class InternalVariableUpdateAction;
class CreatureBehaviorUpdateAction;
class ActivityGroup;
class RayData;
class SbMatrix;
class SoCamera;
class GenericController;
class TextGauge;


class BehaviorCreature : public MotorCreature {
    SO_NODE_HEADER(BehaviorCreature);

public:
    static void initClass();
    SoSFVec3f gaugeOrigin;
    SoSFInt32 traceLevel;
    
    /* these guys are for the behavior system */
    InternalVariableUpdateAction *ivAction;
    CreatureBehaviorUpdateAction *dbAction;
    
    TextGauge *behaviorGauge;
    char *gaugebufs[20];
    int currentRep;
    
    /* purely convenience functions */
    PotentialFieldSensor *getPFSensor();
    SniffSensor *getSniffSensor();
    RayData *getDataForClosestUsingSniff(int whichTag);
    
    void traceBehaviorSystemAt(UpdateStateData &usd);
    
    /* over-rides of methods defined in MotorCreature */
    virtual void updateBehaviorSystemAt(UpdateStateData &usd);
    virtual void changeRep(int newRep);
    virtual void buildBehaviorSystem();

protected:
    BehaviorCreature();       // Note only should be call during a read
    ActivityGroup *topActivityGroup;
    virtual ~BehaviorCreature();
    
}; 

#endif
