#ifndef _CREATUREFRM_ 
#define _CREATUREFRM_

#include <Inventor/SbBasic.h>
#include "CreatureRM.h"
#include <Inventor/fields/SoMFString.h>
#include <Inventor/fields/SoSFEnum.h>
/********************************************************************
 *
 *	CreatureFieldRM
 * 
 ********************************************************************/

class CreatureFieldRM : public CreatureRM {
    SO_NODE_HEADER(CreatureFieldRM);
    public:
    enum LogicalOpType{
	IF_ANY, 
	IF_ALL, 
	IF_NOT_ANY
    }; 
    
    // field for find
    SoSFString findFieldName;
    
    // for filter
    SoMFString filterFieldNames; // these fields need to exist in pronome->object
    SoSFEnum logicalOp;
    SoSFEnum fieldUse;
    
    // for weight
    SoSFString weightFieldName;
    
    public:
    static void initClass();

    CreatureFieldRM();       // Note only should be call during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool readInstance(SoInput *in);
#endif
    virtual ~CreatureFieldRM();

};

// this callback is installed as default filter callback for this class
// if fieldUse == AS_CONDITION (the default)

SbBool filterBoolFields(ReleasingMechanism *rm, BehaviorUpdateAction *act);

// installed as default find callback if fieldUse == AS_POSITION

SbBool findAndUseFieldAsPosition(ReleasingMechanism *rm, BehaviorUpdateAction *act);

void initCreatureFieldRMCallbackList();

/********************************************************************
 *
 *	ProprioceptiveFieldRM
 * 
 ********************************************************************/

class ProprioceptiveFieldRM : public CreatureFieldRM {
    SO_NODE_HEADER(ProprioceptiveFieldRM);
    public:
    BaseBehaviorNode *senseNode;
    void setSenseNode(BaseBehaviorNode *anode);
    static void initClass();

    ProprioceptiveFieldRM();       // Note only should be call during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool readInstance(SoInput *in);
#endif
    virtual ~ProprioceptiveFieldRM();

};
 
#endif  
