#ifndef _CREATURERM_
#define _CREATURERM_

#include <Inventor/SbBasic.h>
#include "ActivityLib_1.h"
class BaseSensor;
class MotorCreature;
/********************************************************************
 *
 *	CreatureRM
 * 
 ********************************************************************/

class CreatureRM : public ReleasingMechanism {
    SO_NODE_HEADER(CreatureRM);
    public:
    
    enum SensingType{
	USEVISIBLEONLY, 
	USESNIFFONLY, 
	USEBEST 
    }; 
    
    SoSFEnum useSensors;
    SoSFBool weightByDistance;
    SoSFString sensorToUse;
    
    public:
    static void initClass();

    virtual void  _updateValue(BehaviorUpdateAction *action);
    
    CreatureRM();       // Note only should be call during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool readInstance(SoInput *in);
#endif
    virtual ~CreatureRM();
    
    BaseSensor *getSensor(MotorCreature *creature);
    /* EFFECTS: Looks for sensorToUse inside creature.  Caches the result,
       so only actually uses creature the first time. */
    /* NOTE: Should only be used by the callback functions. */

  private:
    BaseSensor *sSensor;

};
 
#endif  
