#include "CreatureLib.h"
#include "BehaviorCreatureLib.h"
#include "MotorLib.h"
#include "SensorLib.h"
#include "LeafActivity.h"

int shouldTrace = 0;

#define NOTLOOKEDUPYET -18976 

/***************************************************************
 * 
 *	    Generic Leaf Activity
 * 
 **************************************************************/
SO_NODE_SOURCE(LeafActivity);

LeafActivity::LeafActivity() : BaseActivity()
{
    SO_NODE_CONSTRUCTOR(LeafActivity);
    SO_NODE_ADD_FIELD(usesSchema, (FALSE));
    SO_NODE_ADD_FIELD(schemaCBName, ("none"));
    SO_NODE_ADD_FIELD(defaultCmdName, ("none"));
    SO_NODE_ADD_FIELD(defaultSecondaryCmdName, ("none"));
    defaultCmd = NOTLOOKEDUPYET;
    defaultSecondaryCmd = NOTLOOKEDUPYET;
}

void
LeafActivity::initClass()
{
    SO_NODE_INIT_CLASS(LeafActivity, BaseActivity, "BaseActivity");
}


SbBool	
#ifdef SO_VERSION_REVISION
LeafActivity::readInstance(SoInput *in, unsigned short flags)
#else
LeafActivity::readInstance(SoInput *in)
#endif
{
#ifdef SO_VERSION_REVISION
    if (BaseActivity::readInstance(in, flags)) {
#else
    if (BaseActivity::readInstance(in)) {
#endif
	if(usesSchema.getValue()==TRUE)
	    schema = new PotentialField(64, 64, 1.0);
	if(schemaCBName.getValue() != SbString("none")){
//	    printf("installing schema callback %s \n", 
//	    schemaCBName.getValue().getString());
	    schemaCallback = getGenericCBByName(schemaCBName.getValue());
	    if(schemaCallback != NULL)
		schemaCallback(schema);
	}
	return (1);
    }
    else {
	return (0);
    }
}

LeafActivity::~LeafActivity()
{
    
}


void LeafActivity::doLeafAction(SoAction *action)
{
    CreatureBehaviorUpdateAction *cba = (CreatureBehaviorUpdateAction *)action;
    if(defaultCmd == NOTLOOKEDUPYET){
	// do default primary command
	if(defaultCmdName.getValue() != SbString("none")){
	    defaultCmd = cba->creature->controller
		->getCommandId(defaultCmdName.getValue().getString());
	}
	else
	    defaultCmd = GC_NONESPECIFIED;
	
	// do default secondary command
	if(defaultSecondaryCmdName.getValue() != SbString("none")){
	    defaultSecondaryCmd = cba->creature->controller
		->getCommandId(defaultSecondaryCmdName.getValue().getString());
	}
	else
	    defaultSecondaryCmd = GC_NONESPECIFIED;
    }
//    mcb.init();   Killing off old style commands.  hardts
    mcb.initGeneric();
    mcb.cmd = GC_NONESPECIFIED;
    if(cba->creature->shouldTrace.getValue())
	printf("%s active at %d\n", pname.getValue().getString(), cba->tick);
    
    if(leafCallback != NULL)
	BaseActivity::doLeafAction(action);
    else {
	_doLeafAction(action);
    }
    issueMotorCommand(*cba->creature, mcb);
    if(defaultSecondaryCmd != GC_NONESPECIFIED){
	cba->creature->controller->suggestMotorCommand(
	    MotorCommandBlock(defaultSecondaryCmd), 
	    SuggestedMCB::DO,
	    this, 
	    value.getValue(), 
	    FALSE, 
	    );
    }
}

void LeafActivity::_doLeafAction(SoAction *action)
{
    
}

void LeafActivity::issueMotorCommand(MotorCreature &mc, MotorCommandBlock &mcbToExecute)
{
  mc.controller->executeMotorCommand(mcbToExecute);
  if(mc.shouldTrace.getValue())
	mcbToExecute.print(mc.controller);
}

void LeafActivity::issueSuggestion(MotorCreature &mc, MotorCommandBlock &mcbToExecute)
{
   mc.controller->suggestMotorCommand(mcbToExecute, SuggestedMCB::MODIFY, 
        this, value.getValue(), FALSE);
}
