
#ifndef LEAFACTIVITY
#define LEAFACTIVITY

#include <Inventor/SbBasic.h>
#include "ActivityLib_1.h"
#include "MotorLib.h"
class MotorCreature;
class PotentialField;

class LeafActivity:public BaseActivity{
    SO_NODE_HEADER(LeafActivity);
    public:
    SoSFFloat criticalDistance;
    
    SoSFBool usesSchema;	// does this use a schema (default: NO)
    SoSFString schemaCBName;	// name of callback used to initialize schema
    PotentialField *schema;	// schema
    genericCB schemaCallback;	// callback actually used.
    
    SoSFString defaultCmdName; // default cmd placed into mcb at start of action
    int defaultCmd;
    
    SoSFString defaultSecondaryCmdName; // default secondary command
    int defaultSecondaryCmd;
    
    MotorCommandBlock mcb;
    
    LeafActivity();
    static void initClass();
#ifdef SO_VERSION_REVISION
    virtual SbBool readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool readInstance(SoInput *in);
#endif
    ~LeafActivity();
    virtual void doLeafAction(SoAction *action);
    virtual void issueMotorCommand(MotorCreature &mc, MotorCommandBlock &cb);
    virtual void issueSuggestion(MotorCreature &mc, MotorCommandBlock &mcb);

    /*
     * over-ride this method if you want custom behavior,  or
     * create an activityCB and install it via:
     * setLeafCallback(),  or install the callback by using:
     *	    BaseBehaviorNode::addCallback("name", funcName);
     * and specifying the following in the Behavior File:
     *	    leafCBName "name"
     * 
     */
    virtual void LeafActivity::_doLeafAction(SoAction *action);
    
    private:
	
    
};

#endif
