#ifndef _MOREBEHSKILLS1_
#define _MOREBEHSKILLS1_

#include "MotorLib.h"
#include <Inventor/SbLinear.h>
#include <Inventor/SbPList.h>
class SoSearchAction;
class ActivityGroup;
class BaseBehaviorNode;

/***************************************************
 *	Skill for setting a behavior variable
 *	arg0 -> name of variable
 *	arg1 -> float argument			
 ***************************************************/ 

class SetBehaviorVariable: public MotorSkill
{
    public:
    SetBehaviorVariable(MotorCreature *p, char *pname) ;
    void updateImmediate(void *arg);
};

class SetBoolField: public MotorSkill
{
    public:
    SetBoolField(MotorCreature *p, char *pname) ;
    void updateImmediate(void *arg);
};

class  GetBehaviorStateVector: public MotorSkill
{
    public:
    ActivityGroup *topActivityGroup;
    GetBehaviorStateVector(MotorCreature *p, char *pname) ;
    void updateImmediate(void *arg);
};

/***************************************************
 *	Skill for getting state of motivational variables
 *	retArgs -> list of movations (name) (value) pairs			
 ***************************************************/ 
class  GetMotStateVector: public MotorSkill
{
    public:
    SbPList motlist;
    SoSearchAction *sa;
    GetMotStateVector(MotorCreature *p, char *pname) ;
    void updateImmediate(void *arg);
};

/***************************************************
 *	Skill for getting state of releasing mechanisms
 *	arg0 -> re-aquire releasing mechanisms
 *	arg1 -> optional (node to start at, behaviorRoot by default)
 *	retArgs -> list of active releasing mechanisms			
 ***************************************************/ 
class  GetRMStateVector: public MotorSkill
{
    public:
    SbPList rmlist;
    SoSearchAction *sa;
    GetRMStateVector(MotorCreature *p, char *pname) ;
    void updateImmediate(void *arg);
};

/***************************************************
 *	Skill for building test Releasing Mechanisms
 *	arg0 -> creature which is the target of interest
 *				
 ***************************************************/ 
class  BuildBooleanRMs: public MotorSkill
{
    public:
    BuildBooleanRMs(MotorCreature *p, char *pname) ;
    void updateImmediate(void *arg);
};

/***************************************************
 *	Skill for building Releasing Mechanism to watch an activity
 *	arg0 -> name of behavior node (if null,  then will find active leaf node)
 *	arg1 -> name of where you want to put it (if null will put it up top) 
 *				
 ***************************************************/ 
class  BuildWatchActRM: public MotorSkill
{
    public:
    BuildWatchActRM(MotorCreature *p, char *pname) ;
    void updateImmediate(void *arg);
};

BaseBehaviorNode *getActiveLeafBehavior(SoNode *node);

#endif











