#ifndef _BEHAVIOR_BOOK_
#define _BEHAVIOR_BOOK_

#include <Inventor/SbPList.h>
#include <Inventor/SbString.h>
#include <Inventor/fields/SoMFString.h>
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/fields/SoMFNode.h>
#include <Inventor/fields/SoSFBool.h>
#include "MediaCreature.h"


class GenericController;
class SoInput;
class SoCamera;

// If you change this, you have to change the script which is creating the
// image files
#define NUMFILES 10

// The BehaviorBook also depends (in its RM and action callbacks) on having
// 4 representations: 0 is on the shelf, 1 is opening to the wall, 2 is on
// the wall, and 3 is returning to the shelf

class BehaviorBook : public MediaCreature {
    SO_NODE_HEADER(BehaviorBook);

private:
    short loc;
    SoMFString imageFileNames;

protected:
    BehaviorBook();
#ifdef SO_VERSION_REVISION
    virtual SbBool readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool readInstance(SoInput *in);
#endif
    virtual ~BehaviorBook();

public:
    SoSFFloat moveSpeed, moveTime;
    SoSFBool activated, opening, closing;
    SoSFVec3f startPosition, restPosition; // start on shelf, rest on wall
    SoSFFloat epsilon;		/* how close do we need to be */

    short pageForward();
    short pageBackward();
    short currentPageNum();
    SbString pageForwardName();
    SbString pageBackwardName();
    SbString currentPageName();
    static void initClass();
};

#endif
