#include <iostream.h>
#include <assert.h>
#include <Inventor/SbString.h>
#include <Inventor/fields/SoSFString.h>
#include <Inventor/engines/SoOneShot.h>
#include <Inventor/engines/SoInterpolate.h>
#include <Inventor/nodes/SoShuttle.h>
#include <Inventor/nodes/SoTexture2.h>

#include "ActivityLib_1.h"
#include "BehaviorCreature.h"
#include "BehaviorPerson.h"
#include "util.h"
#include "BasicDefines.h"
#include "MediaCreature.h"
#include "BehaviorBook.h"

#include "BaseBehaviorNode.h"
#include "CreatureRM.h"
#include "CreatureBehavior.h"
#include "LeafActivity.h"
#include "SensorLib.h"
#include "BasicDefines.h"
#include "AliveCamera.h"
#include "Alive.h"

void
goWallCB (BaseActivity *act, BehaviorUpdateAction *action)
{
  // cerr << "in goWallCB"<< endl;
  CBUA(dba,action);
  PRONOME(pronome,dba);
  BehaviorBook *self = (BehaviorBook *)dba->creature;
  SoOneShot *countDown = new SoOneShot;
  //SoInterpolateVec3f* grow = new SoInterpolateVec3f;
  SbVec3f tmp;
  float x, y, z;
  MotorCommandBlock mcb(GC_CHANGEREP);
  MotorCommandBlock mcb2(GC_MOVE_GEN);
  LeafActivity *la = (LeafActivity *)act;

  mcb.setNextArgGeneric((int) RepSwitch::REP_1);
  self->controller->executeMotorCommand(mcb);
  self->changeRep(RepSwitch::REP_1);

  countDown->duration = 15.0; 
  countDown->flags.setValue(SoOneShot::HOLD_FINAL);

  //grow->input0.setValue(1.,1.,1.);
  //grow->input1.setValue(2.,2.,1.);
  //grow->alpha.connectFrom(&countDown->ramp);
  //self->getBodyTransform()->scaleFactor.connectFrom(&grow->output);
  countDown->trigger.touch();
  la->mcb.cmd = GC_HEADTOWARD;
  self->restPosition.getValue().getValue(x, y, z);
  la->mcb.setNextArgGeneric(x);
  la->mcb.setNextArgGeneric(y);
  la->mcb.setNextArgGeneric(z);
  la->issueMotorCommand(*dba->creature,la->mcb);

  mcb2.setNextArgGeneric(ArgType((float)(self->moveSpeed.getValue())));
  mcb2.setNextArgGeneric(ArgType((float)(self->moveTime.getValue())));
  self->controller->executeMotorCommand(mcb2);
  
  self->opening.setValue(TRUE);
}

void
openWallCB (BaseActivity *act, BehaviorUpdateAction *action)
{ 
  //cerr << "in openWallCB"<< endl;
  CBUA(dba,action);
  PRONOME(pronome,dba);
  LeafActivity *la = (LeafActivity *)act;
  BehaviorBook *self = (BehaviorBook *)dba->creature;
  MotorCommandBlock mcb(GC_MOVE_GEN);
  MotorCommandBlock mcb2(GC_CHANGEREP);

  mcb.setNextArgGeneric(ArgType((float)0.0));
  mcb.setNextArgGeneric(ArgType((float).3));
  la->issueMotorCommand(*dba->creature,mcb);
 
  mcb2.setNextArgGeneric((int) RepSwitch::REP_2);
  self->controller->executeMotorCommand(mcb2);
  self->changeRep(RepSwitch::REP_2);
  self->opening.setValue(FALSE);
  self->activated.setValue(TRUE);
}

void
pageForwardCB (BaseActivity *, BehaviorUpdateAction *action)
{ 
  //cerr << "in pageForwardCB"<< endl;
  CBUA(dba,action);
  PRONOME(pronome,dba);
  BehaviorBook *self = (BehaviorBook *)dba->creature;
  SoTexture2 *textureMap = (SoTexture2 *) self->getByName("TextureMap");

/*
  cerr << "loading " << self->pageForwardName().getString() << endl;
  self->pageBackward(); // need to undo the effect of paging foward in
		       // the error check above
		       */
  textureMap->filename.setValue(self->pageForwardName());
}

void
pageBackwardCB (BaseActivity *, BehaviorUpdateAction *action)
{
  //cerr << "in pageBackwardCB"<< endl;
  CBUA(dba,action);
  PRONOME(pronome,dba);
  BehaviorBook *self = (BehaviorBook *)dba->creature;
  SoTexture2 *textureMap = (SoTexture2 *) self->getByName("TextureMap");
/*
  cerr << "loading " << self->pageBackwardName().getString() << endl;
  self->pageForward(); // need to undo the effect of paging back in
		       // the error check above
		       */
  textureMap->filename.setValue(self->pageBackwardName());
}

void
closeCB (BaseActivity *act, BehaviorUpdateAction *action)
{
  //cerr << "in closeCB"<< endl;
  CBUA(dba,action);
  PRONOME(pronome,dba);
  BehaviorBook *self = (BehaviorBook *)dba->creature;
  SoOneShot *countDown = new SoOneShot;
  //SoInterpolateVec3f* grow = new SoInterpolateVec3f;
  SbVec3f tmp;
  float x, y, z;
  MotorCommandBlock mcb(GC_CHANGEREP);
  MotorCommandBlock mcb2(GC_MOVE_GEN);
  LeafActivity *la = (LeafActivity *)act;

  // change object to closingbook picture
  mcb.setNextArgGeneric((int) RepSwitch::REP_3);
  self->controller->executeMotorCommand(mcb);
  self->changeRep(RepSwitch::REP_3);

  countDown->duration = 15.0; 
  countDown->flags.setValue(SoOneShot::HOLD_FINAL);

  //grow->input0.setValue(1.,1.,1.);
  //grow->input1.setValue(1.5,1.5,1.);
  //grow->alpha.connectFrom(&countDown->ramp);
  //self->getBodyTransform()->scaleFactor.connectFrom(&grow->output);
  countDown->trigger.touch();
  la->mcb.cmd = GC_HEADTOWARD;
  self->startPosition.getValue().getValue(x, y, z);
  la->mcb.setNextArgGeneric(x);
  la->mcb.setNextArgGeneric(y);
  la->mcb.setNextArgGeneric(z);
  la->issueMotorCommand(*dba->creature,la->mcb);

  mcb2.setNextArgGeneric(ArgType((float)(self->moveSpeed.getValue())));
  mcb2.setNextArgGeneric(ArgType((float)(self->moveTime.getValue())));
  self->controller->executeMotorCommand(mcb2);

  self->activated.setValue(FALSE);
  self->closing.setValue(TRUE);
}

void
closeShelfCB (BaseActivity *act, BehaviorUpdateAction *action)
{ 
  //cerr << "in closeShelfCB"<< endl;
  CBUA(dba,action);
  PRONOME(pronome,dba);
  LeafActivity *la = (LeafActivity *)act;
  BehaviorBook *self = (BehaviorBook *)dba->creature;
  MotorCommandBlock mcb(GC_MOVE_GEN);
  MotorCommandBlock mcb2(GC_CHANGEREP);
  MotorCommandBlock mcb3(GC_HEADTOWARD);
  float x, y, z;

  mcb.setNextArgGeneric(ArgType((float)0.0));
  mcb.setNextArgGeneric(ArgType((float).3));
  la->issueMotorCommand(*dba->creature,mcb);
 
  mcb2.setNextArgGeneric((int) RepSwitch::REP_0);
  self->controller->executeMotorCommand(mcb2);
  self->changeRep(RepSwitch::REP_0);
  // now orient yourself correctly on the shelf
  self->restPosition.getValue().getValue(x, y, z);
  mcb3.setNextArgGeneric((float)0.0);
  mcb3.setNextArgGeneric((float)y);
  mcb3.setNextArgGeneric((float)-60);
  self->controller->executeMotorCommand(mcb3);
  self->closing.setValue(FALSE);
}

void
initBehaviorBookActionCallbackList ()
{
  BaseBehaviorNode::addCallback("goWall", goWallCB);
  BaseBehaviorNode::addCallback("openWall", openWallCB );
  BaseBehaviorNode::addCallback("pageForward", pageForwardCB);
  BaseBehaviorNode::addCallback("pageBackward", pageBackwardCB);
  BaseBehaviorNode::addCallback("close", closeCB);
  BaseBehaviorNode::addCallback("closeShelf", closeShelfCB);
}

