#ifndef _CARDEF_
#define _CARDEF_

#include <Inventor/SbBasic.h>
#include <Inventor/SbPList.h>
#include "MotorCreature.h"

class GenericController;
class SoInput;
class SoCamera;
class CarController;

class Car : public MotorCreature {
    SO_NODE_HEADER(Car);

public:
    static void initClass();

    SoSFFloat wheelBase;    
    SoSFFloat wheelRadius;    
    float     wheelCircum;

    
    /* over-rides of methods defined in MotorCreature */
    
    virtual void getDOFInterpolators();
    virtual void addMotorSkills();
    virtual void addBehaviorSystem();
    void         getEyeView(SoCamera *xf);


protected:
    Car();           // Note only should be called during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool	readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool	readInstance(SoInput *in);
#endif
    virtual ~Car();
    
}; 

#endif
