#ifndef _BSINTERV3F_
#define _BSINTERV3F_

#include <Inventor/engines/SoSubEngine.h>
#include <Inventor/fields/SoSFFloat.h>
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/fields/SoSFFloat.h>
#include <Inventor/fields/SoSFShort.h>
#include <Inventor/fields/SoMFVec3f.h>
#include <Inventor/fields/SoSFVec4f.h>
#include <Inventor/fields/SoSFNode.h>
#include <Inventor/fields/SoSFBool.h>
#include <Inventor/fields/SoSFMatrix.h>
#include <Inventor/engines/SoInterpolate.h>
#include <Inventor/SbLinear.h>

#include "BSpline.h"

class BSInterpV3f : public SoInterpolate {

    SO_ENGINE_HEADER(BSInterpV3f);

  public:

    // Input:
    SoSFShort       degree;
    SoMFVec3f       controlPoints;
    SoSFNode        geomSep;
    SoSFMatrix	    transform;
    
    // Output:

    static void initClass();

    BSInterpV3f();

    void pointOnCurve(float t,SbVec3f &vec);
    void deltaOnCurve(float t1, float t2, SbVec3f &vec);


  private:

    SoSeparator *curveSep;
    SoSeparator *inputSep;
    BSpline     *mySpline;

    void addEditables();

    virtual ~BSInterpV3f();
    virtual void inputChanged(SoField *whichField);
    virtual void evaluate();

    void transformControlPts(SbVec3f *transformedPts);

};

#endif
