#ifndef _BSPLINE_
#define _BSPLINE_
#include <Inventor/SbBasic.h>
#include <Inventor/SbLinear.h>
#include "../CreatureLib/Vector.h"

class SbVec3f;
class SbVec2f;
class SoSeparator;
class SoCoordinate3;

class BSpline{

  private:
    int order;
    int numKnots;
    int numControlPts;
    int ft;

    Vector knots;
    SbVec3f *controlPts;

    SoCoordinate3 *coords;
    SbVec3f vertices[32];
  public:

    BSpline(int degree, int nControlPts);
    ~BSpline();

    int getNumControlPts() { return numControlPts; };
    int pointOnCurve(float t,SbVec3f &p, SbBool ifContinuous=FALSE);

    SoSeparator *generateCurve();
    void updateCurve();
    SoSeparator *generateMyCurve();

    void setControlPts(const SbVec3f *data);
    void fitToData(int numpts, SbVec3f *pts, int useChordLength);
    
 protected:
    void cacheVertices();

};

#endif

