#ifndef _CONTROLPOINTS_
#define _CONTROLPOINTS_

#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/fields/SoSFVec4f.h>
#include "Translate222Manip.h"

class SoSeparator;
class SoShape;
class SoTransform;
class ControlPoint;

class ControlPoint : public SoSeparator {

    SO_NODE_HEADER(ControlPoints);

public:
    static void initClass();

    ControlPoint(SbVec3f pos, int index, SoMFVec3f *cf);

    SoTransform *getTransform() { return (SoTransform *)getChild(translate_index); };

    static ControlPoint *isSelection(SoPath *p); 
    void addManipulator(SoPath *p);
    void removeManipulator();

protected:
    ControlPoint();
    static void dragMotionCallback(void *data, SoDragger *);

private:

    Translate222Manip *myManip;
    SoPath *manipPath;

    static int translate_index;
    static int sphere_index;

    int index;
    SoMFVec3f *changeField;

    virtual ~ControlPoint();
};

#endif
