#include <Inventor/nodes/SoSubNode.h>
#include <Inventor/fields/SoMFVec3f.h>
#include <Inventor/engines/SoInterpolate.h>
#include "BSInterpV3f.h"
#include "EngineHolder.h"

SO_NODE_SOURCE(EngineHolder);

void
EngineHolder::initClass()
{
    SO_NODE_INIT_CLASS(EngineHolder, SoNode, "Node");
}

EngineHolder::EngineHolder()
{
    SO_NODE_CONSTRUCTOR(EngineHolder);
    
    SO_NODE_ADD_FIELD(i0, (0, 0, 0));
    SO_NODE_ADD_FIELD(i1, (0, 0, 0));
    SO_NODE_ADD_FIELD(i2, (0, 0, 0));
    
    SO_NODE_ADD_FIELD(i3, (0, 0, 0));
    SO_NODE_ADD_FIELD(i4, (0, 0, 0));
    SO_NODE_ADD_FIELD(i5, (0, 0, 0));
    
    SO_NODE_ADD_FIELD(i6, (0, 0, 0));
    SO_NODE_ADD_FIELD(i7, (0, 0, 0));
    SO_NODE_ADD_FIELD(i8, (0, 0, 0));
    
    SO_NODE_ADD_FIELD(i9, (0, 0, 0));
    SO_NODE_ADD_FIELD(i10, (0, 0, 0));
    SO_NODE_ADD_FIELD(i11, (0, 0, 0));
    SO_NODE_ADD_FIELD(tol, (.01));
    int i;
    for(i=0;i<MAXNUMCACHES;i++)
	jointCaches[i] = new SbPList;
}

EngineHolder::~EngineHolder()
{
}

int
EngineHolder::connectEngineTo(int whichEngine, SoMFVec3f *dest)
{
    SoEngineOutput *eo;
    BSInterpV3f *bsi;
    SoMFVec3f *whichField;
    
    switch(whichEngine){
	case 0: {whichField = &i0; break;}
	case 1: {whichField = &i1; break;}
	case 2: {whichField = &i2; break;}
	case 3: {whichField = &i3; break;}
	case 4: {whichField = &i4; break;}
	case 5: {whichField = &i5; break;}
	case 6: {whichField = &i6; break;}
	case 7: {whichField = &i7; break;}
	case 8: {whichField = &i8; break;}
	case 9: {whichField = &i9; break;}
	case 10: {whichField = &i10; break;}
	case 11: {whichField = &i11; break;}
	default : return EngineHolder::NOT_CONNECTED_BAD_INDEX;
    }
    if((whichField->getConnectedEngine(eo))){
	 bsi = (BSInterpV3f *)eo->getContainer();
	 dest->connectFrom(&bsi->output);
	 return EngineHolder::CONNECTED;
    }
    else return EngineHolder::NOT_CONNECTED;
} 

SbPList *EngineHolder::getJointCache(int which)
{
    return (SbPList *)jointCaches[which];
}
    
float EngineHolder::getTolerance(int which)
{
    return (float)tol[which];
}
     
void EngineHolder::setJointCache(int which, SbPList *cache)
{
    jointCaches[which] = cache;
}
