#include <Inventor/nodes/SoSubNode.h>
#ifndef ENGINEHOLDER
#define ENGINEHOLDER

#include <Inventor/fields/SoMFVec3f.h>
#include <Inventor/fields/SoMFFloat.h>
#define MAXNUMCACHES 4
class EngineHolder :public SoNode {
    SO_NODE_HEADER(EngineHolder);
    public:
    enum State {
	CONNECTED, 
	NOT_CONNECTED, 
	NOT_CONNECTED_BAD_INDEX
    };
    /* caches 4 sets of 3 engine tuples */
    SoMFVec3f i0;
    SoMFVec3f i1;
    SoMFVec3f i2;
    
    SoMFVec3f i3;
    SoMFVec3f i4;
    SoMFVec3f i5;
    
    SoMFVec3f i6;
    SoMFVec3f i7;
    SoMFVec3f i8;
    
    SoMFVec3f i9;
    SoMFVec3f i10;
    SoMFVec3f i11;
    
    SbPList *jointCaches[MAXNUMCACHES]; // each entry is a SbPlist of caches
    SoMFFloat tol;
    static void initClass();
    EngineHolder();
    ~EngineHolder();
    
    int connectEngineTo(int which, SoMFVec3f *d1);
    
    SbPList *getJointCache(int which);
    void setJointCache(int which, SbPList *cache);
    float getTolerance(int which);
};

#endif
