#include "JointDragger.h"
#include "JointManip.h"
#include "AnchorDragger.h"
#include "AnchorManip.h"
#include "Translate222Dragger.h"
#include "Translate222Manip.h"

#include "LimbModel.h"
#include "JointModel.h"
#include "ArticulatedBody.h"
#include "ControlPoint.h"
#include "BaseCreature.h"

#include "BSInterpV3f.h"
#include "EngineHolder.h"
#include "RepSwitch.h"
#include "TimeDependentComponent.h"

void CreatureLibInit()
{

   // Initialize the new node classes
   //
   // Draggers and Manipulator
   //
   JointDragger::initClass();
   JointManip::initClass();
   AnchorDragger::initClass();
   AnchorManip::initClass();
   Translate222Dragger::initClass();
   Translate222Manip::initClass();

   //
   // Nodes
   //
   LimbModel::initClass();
   JointModel::initClass();
   ArticulatedBody::initClass();
   ControlPoint::initClass();
   BaseCreature::initClass();
   TimeDependentComponent::initClass();
   RepSwitch::initClass();
   RepContainer::initClass();
   //
   // Engines
   //
   BSInterpV3f::initClass();
   EngineHolder::initClass();
   
   ChangeRepAction::initClass();
}
