#ifndef INTEGRATOR
#define INTEGRATOR

#include "../CreatureLib/vector.h"

typedef struct{
    float  time;
    vector y;
    vector ydot;
}derivStruct;

typedef struct _h{
    float time;
    float h;
    vector wvalues;
    vector fvalues;
} historyStruct;

class Integrator{
    historyStruct hist;
    float  stepsize;
    float  time;
    int nVar;
    void *client;
    int okToOverShoot;
    int globalTimeStamp;
    float   globalTime;
    float  dTime;
    float  tTime;
    
public:
    int restart;
    float  maxStepsize;
    float  minStepsize;
    float  maxError;
    Integrator();
    float dispatchDeriv(float time, vector y, vector ydot);
    void initializeIntegrator();
    void initForNumVariables(int n ,float minS ,float maxS,float me , void *aClient);
    int rkf(vector yin,int n,vector yout, float tMin,float tMax,
	    float eps,float hMin,float hMax);
    void restartIntegrator();
    void setClient(void *anObject);
    void setMinStepsize(float s);
    void setMaxStepsize(float s);
    void setMaxError(float e);
    void setOkToOverShoot(int yn);
    float stepToAndOk(float t ,int *yn);
    void setTime(float t);
};

#endif


    
