/*
 */

/*-------------------------------------------------------------
 *----------------------------------------------------------*/

#include <Inventor/nodes/SoSurroundScale.h>

#include "JointDragger.h"
#include "JointManip.h"

SO_NODE_SOURCE(JointManip);

//  Initialize the type ID for this manipulator node. This
//  should be called once after SoInteraction::init(),
//  TranslateRadialDragger::initClass()
//  and JointDragger::initClass()
void
JointManip::initClass()
{
   SO_NODE_INIT_CLASS(JointManip, SoTransformManip, "TransformManip");
}

JointManip::JointManip()
{
   SO_NODE_CONSTRUCTOR(JointManip);

   // Create a new dragger and call setDragger(), 
   // a method inherited from SoTransformManip.
   JointDragger *myDrag = new JointDragger;
   setDragger(myDrag);

   // We want this manipulator to surround the objects it
   // affects when we put it in a scene. So create the
   // surroundScale node.
//   SoSurroundScale *mySS = (SoSurroundScale *) 
//      myDrag->getPart("surroundScale",TRUE);
//   mySS->numNodesUpToContainer = 4;
//   mySS->numNodesUpToReset = 3;
}

JointManip::~JointManip()
{
}
