#ifndef _KALMAN_
#define _KALMAN_
#include <Inventor/SbLinear.h>
#include "Vector.h"

class Kalman {
    Vector y;
    Matrix F;
    Matrix H;
    Matrix K;
    Matrix Q;
    Matrix R;
    Matrix P;
    Matrix Pstar;
    Matrix Phi;
    float dt;
    int numEstimates;
    public:
    Vector x;
    Vector xstar;
    Kalman(float ddt, Vector e, Vector n);
    void initializeMatrices(Vector e, Vector n);
    void print();
    void initialState(Vector Xo);
    void prediction();
    void update(float newx, float newy, float newz);
    void updateStateEstimate(SbVec3f &se);
    void getStateEstimate(SbVec3f &se);
};
#endif
