#ifndef _LIMBMODEL_
#define _LIMBMODEL_

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>

class SoSeparator;
class SoShape;
class SoTransform;
class LimbModel;

class LimbModel : public SoSeparator {

    SO_NODE_HEADER(LimbModel);

public:

    static void initClass();
    LimbModel(float l, float r);
    LimbModel(SoTransform *t, SoSeparator *s);

    SoTransform *getTransform();               // index number 0
    void        setTransform(SoTransform *tx);

    SoSeparator *getShapeSep();
    void        setShapeSep(SoSeparator *s);   // index number 1

    void        setLengthRadius(float l, float r);

protected:
    LimbModel();

private:
    void buildLimb(float length, float radius);
    void buildLimb();
    virtual ~LimbModel();
};

#endif
