#ifndef __RANDOM_VAR__
#define __RANDOM_VAR__

#include <stdlib.h>
#include <inttypes.h>
/* 
   RandomVariable
   This is an abstract class, which can be implemented in various ways,
   with different distributions
   */
class RandomVariable
{
public:
  
  double operator() () { return generate(); } // generate a number
  virtual double generate()=0; // actually generate it
  virtual void seed();	// pick a good one 
  virtual void seed(int32_t seedval);	// use mine
};

#endif
