#ifndef SPATIAL
#define SPATIAL

#include <Inventor/SbLinear.h>
#include "../CreatureLib/vector.h"

class Spv {
    public :
    SbVec3f v;
    SbVec3f v0;
    Spv();
    Spv(SbVec3f a,SbVec3f b);
    Spv spvFromForce(SbVec3f force,SbVec3f offset);
    Spv operator+(Spv &arg);
    Spv operator-(Spv &arg);
    Spv cross(Spv *arg);
    void setValue(float *vec);
    void getValue(float *vec);
    void print();
};

class Rbi{
    public :
    float m;
    SbVec3f h;
    SbMatrix I;
    Rbi();
    Rbi(SbMatrix inertia, float mass, SbVec3f op);
    void Rbi::multSpv(Spv *arg);
    float Rbi::kineticEnergy(Spv *arg);
    void print();
};


class Spx {
    public :
    SbMatrix e;
    SbVec3f r;
    Spx();
    Spx(SbMatrix e1,SbVec3f r1);
    Spx Spx::inverse();
    void  multSpv(Spv *arg);
    void  multInvSpv(Spv *arg);
    Spx & multSpx(Spx *arg);
    Spx & multInvSpx(Spx *arg);
    void  multRbi(Rbi *arg);
    void  multVec(SbVec3f *pt);
    void  multInvVec(SbVec3f *pt);
    void print();
};

class Scr{
    public:
    static int XAXIS;
    static int ZAXIS;
    static int YAXIS;
    float a;
    float d;
    float c;
    float s;
    float axis;
    int zeroTwist;
    int zeroDisplacement;
    Scr(float ang,float disp, int whichAxis);
    void setTwist(float t);
    void setDisplacement(float disp);
    void multSpv(Spv *arg);
    void multRevoluteZ(Spv *arg);
    void multVec(SbVec3f *vec);
    void multInvVec(SbVec3f *v);
    void rotVec(SbVec3f *vec);
    void rotInvVec(SbVec3f *v);
};

/* some utility functions */
matrix rbiToMatrix(Rbi &r,matrix m);
SbVec4f SbRotationDeriv(SbRotation &sb,SbVec3f  w);
void symmetricRbiInverseMultSpv(matrix irbi,Spv *sv);
#endif






