#include <stdio.h>

#include <Inventor/Sb.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoDB.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoRotation.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/SoPath.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoDrawStyle.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/fields/SoSFNode.h>
#include "TimeDependentComponent.h"
#include "BaseCreature.h"

/*********************************************************************
 * 
 *	    TimeDependentComponent  Class
 * 
 *********************************************************************/


SO_NODE_SOURCE(TimeDependentComponent);

void
TimeDependentComponent::initClass()
{
    SO_NODE_INIT_CLASS(TimeDependentComponent, SoSeparator, "Separator");
}

TimeDependentComponent::TimeDependentComponent() : SoSeparator(2)
{
    SO_NODE_CONSTRUCTOR(TimeDependentComponent);
}

TimeDependentComponent::~TimeDependentComponent()
{
}

void TimeDependentComponent::initializeComponent(SoGroup *root)
{
    base = root;
}

void TimeDependentComponent::updateStateAt(UpdateStateData &usd)
{
    return;
}

SoPath *TimeDependentComponent::buildPath(SoNode *startNode, SoNode *endNode)
{
    SoPath *pp;
    
    /* build path to sensorFrame */
    SoSearchAction sa;
    sa.setNode(endNode);
    sa.apply(startNode);
    pp = sa.getPath();
    pp->ref();
    if(pp==NULL)
        printf("path wasn't created \n");
//    else
//        printf("path created \n");
    return pp;
}
