#ifndef _TIMEDEPENDENTCOMPONENT_
#define _TIMEDEPENDENTCOMPONENT_

#include <Inventor/SbLinear.h>
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/fields/SoSFFloat.h>
#include <Inventor/sensors/SoFieldSensor.h>
#include <Inventor/fields/SoMFVec3f.h>
#include <Inventor/fields/SoSFInt32.h>
#include <Inventor/fields/SoMFNode.h>
#include <Inventor/fields/SoSFNode.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoSeparator.h>
#include "BaseCreature.h"

class SoNode;
class SoPath;

class TimeDependentComponent : public SoSeparator {
    SO_NODE_HEADER(TimeDependentComponent);

public:
    SoNode *base;
    static void initClass();
    virtual void initializeComponent(SoGroup *root);
    virtual void updateStateAt(UpdateStateData &usd);

protected:
    TimeDependentComponent();       // Note only should be call during a read
    SoPath *buildPath(SoNode *startNode, SoNode *endNode);
    virtual ~TimeDependentComponent();

};

#endif

