#include <sys/time.h>
#include "TimeStat.h"
#include <stdio.h>

Timestat::Timestat(const char *pn,float ap)
{
  pname = pn;
  avgingPeriod = ap;
  period = 0;
  totalTime = 0;
  avgTime = 0;
  starttime = SbTime(0.0);
}

void Timestat::init()
{ 
  period = 0;
  totalTime = 0;
  avgTime = 0;
  starttime = SbTime(0.0);
}

void Timestat::startTime()
{
  starttime = SbTime::getTimeOfDay();
}

void Timestat::endTime()
{
    endtime = SbTime::getTimeOfDay();
    totalTime += (endtime-starttime).getValue();
    period++;
    if(period == avgingPeriod){
	avg();
	print();
	init();
    }
}

void Timestat::avg()
{
  avgTime = totalTime/(float)period;
}

void Timestat::print()
{
  printf("avg time for %s is %f\n",pname,avgTime);
}
