#ifndef MATRIXCLASS
#define MATRIXCLASS
#include "../CreatureLib/vector.h"
	
class Vector {
    public:
    int m;
    float mm[33];
    Vector();
    Vector(int row);
    ~Vector();
    Vector shift(int i);
    float sum();
    float abssum();
    float dot(const Vector &m1);
    friend Vector operator+(const Vector &m1, const Vector &m2);
    friend Vector operator-(const Vector &m1, const Vector &m2);
    friend Vector operator*(const Vector &m1, const Vector &m2);
    Vector &operator=(const Vector &m2);
    void print();
    void print(const char *title);
};

class Matrix {
    public:
    int m;
    int n;
    matrix mm;
    Matrix();
    Matrix(const Matrix &m);
    Matrix(int row, int col);
    ~Matrix();
    Matrix &identity();
    Matrix &operator=(const Matrix &m2);
    friend Matrix operator*(const Matrix &m1, const Matrix &m2);
    friend Matrix operator*(const Matrix &m1, const float &s);
    friend Matrix operator+(const Matrix &m1, const Matrix &m2);
    friend Matrix operator-(const Matrix &m1, const Matrix &m2);
    friend Vector operator*(const Matrix &m1, const Vector &v2);
    Matrix transpose();
    Matrix inverse();
    Matrix inverseSVD();
    Vector solve( const Vector &b);
    void print();
    void print(const char *title);
};

#endif


