#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "rand.h"

static int iseed = -1;

#define M 100000000
#define M1 10000
#define B 31415821

static int a[55];
static int jindex=13;

int rmult(int p, int q)
{
    int p1,p0,q1,q0;
    
    p1 = p/M1;
    p0 = p%M1;
    q1 = q/M1;
    q0 = q%M1;
    return (((p0*q1+p1*q0)%M1)*M1+p0*q0) %M;
}

void randinit(int s)
{
    for(a[0]=s,jindex =1; jindex<=54; jindex++)
	a[jindex] = (rmult(a[jindex-1],31)+1)%M;
    return;
}

int randint(int r)
{
    int res;
    jindex = (jindex+1)%55;
    a[jindex] = (a[(jindex+23)%55] + a[(jindex+54)%55]) %M;
    res = (((a[jindex]/M1)*r)/M1);
    //printf("%d %d \n",r,res);
    return res;
}


#define CHECKSEED() if(iseed<0)rand0Init();

float ran0(int *idum)
{
    static float y,maxran,v[98];
    float dum;
    static int iff = 0;
    int j;
    unsigned i,k;

    if(*idum <0 || iff==0){
	iff =1;
	i=2;
	do{
	    k=i;
	    i<<=1;
	}while(i);
	maxran=k;
	srandom(*idum);
	*idum = 1;
	for(j=1;j<=97;j++) dum = random();
	for(j=1;j<=97;j++) v[j] = random();
	y=random();
    }
    j = (int)(1 +97.0*y/maxran);
    if(j>97 || j<1)
	printf("big problems in random number generator \n");
    y=v[j];
    v[j] = random();
    return y/maxran;
}

void rand0Init()
{
    randinit(79773);
    ran0(&iseed);
    iseed = 1;
    return;
}

float rand0()
{
    int i=1;
    float res;
    
    CHECKSEED();
    res = randint(10001)/10000.0;
    return res;
    //return ran0(&i);
}

float randFloatInInterval(float low,float high)
{
    int i=1;
    float ff = 0;
    
    CHECKSEED();
    ff = ran0(&i)*(high-low)+low;
    //printf("%f \n", ff);
    return ff;
}

int randOverThreshold(float t)
{
    return (randFloatInInterval(0, 1)>=t)?1:0;
}

int randIntInInterval(int low, int high)
{
    CHECKSEED();
    return randint(high+1);
}

int randIntInInterval2(int low,int high)
{
    int i=1;
    int res;
    float fres;
    float delta = .49999;
    float l=low,h=high;
    static int j=1;
    
    if(low == high)
	return low;
    if(low > high){
	printf("lower limit greater than high limit \n");
	return randIntInInterval(high,low);
    }
    
    CHECKSEED();
    fres = ran0(&i);
    l -= delta;
    h += delta;
    fres =(fres*(h-l)+l);
    res = (int)rint(fres);
    if(res>high)
	res = randIntInInterval(low,high);
    else if(res<low)
	res = randIntInInterval(low,high);
    return res;
}

float chisquare(int N,int r,int s)
{
    int i,t,f[1000];
    
    randinit(s);
    for(i=0;i<r;i++) f[i] = 0;
    for(i=0;i<N;i++){
	t = randint(r);
	printf("%d\n",t);
	f[t]++;
    }
    for(i=0,t=0;i<r;i++) t+=f[i]*f[i];
    return (float)(((float)r*t/N)-N);
}

void rmain()
{
    int i,k=4,c=100;
    int idnum = -1;
    float f,j,fsum=0;
    int inum[4];
    
    for(i=0;i<k;i++)
	inum[i]=0;
    for(i=0;i<c;i++){
	idnum = randIntInInterval(0,k-1);  
	inum[idnum]++;
    }
    for(i=0;i<k;i++){
	j = ((inum[i]- (float)c/k)*(inum[i]- (float)c/k)/((float)c/k));
	
    }
    printf("chi square => %f\n",j);
    j = chisquare(c,k,79773);
    printf("chi square => %f\n",j);
    return;
}
    
	    
