#ifndef _ALIVE_CLIENT_
#define _ALIVE_CLIENT_
#include <inttypes.h>
#include "AliveBase.h"
#include "AliveDispatch.h"
#include "SocketClient.h"

class AliveClient : public AliveBase {
private:
  SocketClient *tcp_sc; // for high bandwidth transfers
			// i.e. geometry and texture maps
  SocketClient *udp_sc; // for low bandwidth, tick-based updates
			// like behavior system updates and contours
  uint32_t my_address;
  uint32_t server_address;
  int getMyAddress();
  int getServerAddress(char *server_name);
  int serverIsValidatingMe(SocketBuf *sb);

  friend class AliveDispatch;

public:
  AliveClient();
  ~AliveClient();
  int connectToServer(char *server_name);
};

#endif

