#ifndef DOGDEF
#define DOGDEF

#include <Inventor/SbPList.h>
#include "MotorLib.h"
#include "CreatureLib.h"
#include "DogDefines.h"

class SbMatrix;
class SoCamera;
class DogController;

class Dog : public MotorCreature {
    SO_NODE_HEADER(Dog);

public:
    static void initClass();
    SoSFBool newStyleNeck;
    
    /* over-rides of methods defined in MotorCreature */
    
    virtual void getDOFInterpolators();
    
    virtual void addMotorSkills();
    
    virtual GenericController *addController();
    
    int stepTo(UpdateStateData &usd);
    
    void getEyeView(SoCamera *xf);
    
    virtual int checkIfReadyToMove(MotorCommandBlock &mcb);
    
    virtual int checkIfNeedToChangePosture(MotorCommandBlock &mcb, int cmd);
    
    virtual int checkIfNeedToChangePosture(MotorCommandBlock &mcb, MotorSkill *thisOwner);

    Dog();       // Note only should be call during a read
    
    

protected:
    virtual ~Dog();
    
}; 

#endif
