#ifndef DOGDEFINES
#define DOGDEFINES
/*************************************************************************
 * These are the indices into the Dofs list. They correspond exactly to the
 * order that they were added
 *************************************************************************/

#define FLLSTEPPER_INDEX 0
#define FRLSTEPPER_INDEX 1
#define RLLSTEPPER_INDEX 2
#define RRLSTEPPER_INDEX 3
#define SHOULDER_INDEX 4
#define FRONTBACKY_INDEX 5
#define FRONTBACKZ_INDEX 6
#define BACKBACKY_INDEX 7
#define BACKBACKZ_INDEX 8
#define TAILX_INDEX 9
#define TAILZ_INDEX 10
#define NECKJOINTZ_INDEX 11
#define HEADJOINTY_INDEX 12
#define HEADPEND_INDEX 13
#define HEADJOINT_INDEX 13
#define EYEBALLPEND_INDEX 14
#define EYEBROWSHUTTLE_INDEX 15
#define EYEBROWRX_INDEX 16
#define EYEBROWLX_INDEX 17
#define EARLZ_INDEX 18
#define EARRZ_INDEX 19
#define MOUTH_INDEX 20
#define NOSEPEND_INDEX 21
#define SHOULDERHEIGHT_INDEX 22
#define HEADJOINTZ_INDEX 23
#define RLLEGLIFTER_INDEX 24
#define RRLEGLIFTER_INDEX 25
#define NECKAB_INDEX 26
#define EARTIP_INDEX 27
#define TEETHR_INDEX 28
#define TEETHL_INDEX 29
/*************************************************************************
 *  These are used by DogMotorSkills
 *************************************************************************/
#define DOG_GAIT_WALK 0
#define DOG_GAIT_BOUND 1

/***************************************************************
 *
 *	    MOTOR COMMANDS
 * 
 * 
 **************************************************************/
#define GC_FWD        0
#define GC_RGT        1
#define GC_LFT        2
#define GC_HALT       3
#define GC_GOSTRAIGHT 4
#define GC_LFTFWD     5
#define GC_RGTFWD     6
#define GC_WAGTAIL    7
#define GC_MOVETAIL   8
#define GC_SIT        9
#define GC_STAND      10
#define GC_SHAKEHEAD  11
#define GC_TURNHEAD   12
#define GC_LOWERNECK   13
#define GC_MOVEEARS   14
#define GC_SNIFF      15
#define GC_MOVEBROWS  16
#define GC_SHIFTEYES  17
#define GC_TILTHEAD   18
#define GC_SHAKEPAW   19
#define GC_BEG	      20
#define GC_STANDFROMBEG	 21
#define GC_MOVEMOUTH  22
#define GC_CHEW       23
#define GC_NOD        24
#define GC_MOVEHEADZ  25
#define GC_BACK       26
#define GC_BOUND      27
#define GC_STOPSHAKEPAW   28
#define GC_CROUCH   29
#define GC_STANDFROMCROUCH   30
#define GC_STOPTAIL   31
#define GC_LIEDOWN   32
#define GC_STANDFROMLIEDOWN   33
#define GC_STOPSHAKE 34
#define GC_STOPTURNHEAD 35
#define GC_STOPSNIFF 36
#define GC_STOPTILTHEAD 37
#define GC_STOPMOVEHEADZ 38
#define GC_RAISENECK 39
#define GC_STOP 40
#define GC_STRAIGHT 41
#define GC_STANDALL 42
#define GC_GOSTRAIGHTBOUND 43
#define GC_LOOKAT 44
#define GC_LIFTLEG 45
#define GC_LOWERLEG 46
#define GC_BUGEYES 47
#define GC_SHOWTEETH 48
#define GC_BARK 49
/*************************************************************************
 *  These are used by DogController
 *************************************************************************/
#define DEFAULT_TURN .1
#define DEFAULT_SPEED .1
#define DEFAULT_STRAIGHT .5
#define DEFAULT_RIGHT 0
#define DEFAULT_LEFT 1
#define DEFAULT_STAND 0.0
#define DEFAULT_SIT 1.0


#endif





