#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/SbLinear.h>
#include <Inventor/sensors/SoSensor.h>
#include <Inventor/nodekits/SoShapeKit.h>
#include <Inventor/nodes/SoBaseColor.h>
#include "BrioWorld.h"
#include "Brio.h"
#include "Creature.h"
#include "Tree.h"
#include "Wall.h"
#include "Seed.h"
#include "HamsterLib/hamsterdamInit.h"
#include "Person.h"
#include "HotItem.h"
#include "World.h"
#include "Dog.h"
#include "DogDish.h"

/***********************************************************************
 *
 *		Build Table 
 *
 ***********************************************************************/
extern Table *table;
extern HotItem *gateButton;
extern Gate *gate;
static  HotItem *worldSwitch = NULL;
extern Person *person;
#define COGH 1.0
#define COGW 1.0


extern float TABLETOL;
extern float WGPTOL;
extern float WGPERIOD;


void initDogWorld(BrioWorld *myBrioWorld, int ifPred,int ifFood, int ifLive, int
    ifDemo, float sf)
{
    
    SbVec3f WGP = SbVec3f(WXL(WRIGHT), WXL(48), WXL(WBACK-12));
    SbVec3f WTP = SbVec3f(WXL(WLEFT)-2.5, 0, WXL((WBACK+5)));
    SbVec3f WSP = SbVec3f(WXL(10), WXL(48), WXL(WBACK-12));

  
    Creature *pred=NULL;
    
    /* add adog */
    Dog *dog;
    SbVec3f home[2],entrance;
    Creature *tmp;
    SoBaseColor *bc = new SoBaseColor;
    bc->rgb.setValue(.3, 0, 0);

    SoCube *gnd = new SoCube;
    SoCube *box = new SoCube;
    gnd->height = .1;
    gnd->width = WXL(WRIGHT) - WXL(WLEFT);
    gnd->depth = WXL(WFRONT) - WXL(WBACK);
    myBrioWorld->myScene->addChild(gnd);
    box->height = box->depth = box->width = 1;
    SoSeparator *sep = new SoSeparator();
    SoTransform *xf = new SoTransform();
    myBrioWorld->myScene->addChild(sep);
    xf->translation.setValue(0,0, 20);
    sep->addChild(xf);
    sep->addChild(bc);
    sep->addChild(box);
    
    home[0].setValue(WXL(WLEFT),-1,WXL(WFRONT-30.0));
    home[1].setValue(WXL(WLEFT + 36.0),10/sf,WXL(WFRONT));
    entrance.setValue(WXL(WLEFT + 30.0),0,WXL(WFRONT-24.0));
    dog = (Dog *)new Dog(SbVec3f(0/sf,11,20/sf),SbVec3f(20,11,4),2, ifDemo);
    dog->setHome(&home[0],&entrance);
    myBrioWorld->addCreature(dog);
	
    
    if(ifLive ){
	person = new Person(SbVec3f(-105,1.1,-1), SbVec3f(1,3,1),4, worldSwitch);
	person->setVisible(1);
	person->behaviorCyclesPerUpdate = 1;
	myBrioWorld->addCreature(person);
	myBrioWorld->addCreature(person->theBodyParts[0]);
	myBrioWorld->addCreature(person->theBodyParts[1]);
	myBrioWorld->addCreature(person->theBodyParts[2]);
    }

    // change by MPJ 8/1/ midnight   
      worldSwitch = makeWorldButton(myBrioWorld, SbVec3f(9, 12, 1.5), WSP, sf, WGPERIOD);
    worldSwitch->target = person;
    person->worldSwitch = worldSwitch;
    worldSwitch->offColor = SbColor(1, 0, 0);
    worldSwitch->switchState(0);
    myBrioWorld->setWorldSwitch(worldSwitch);
    // end MPJ
      

    myBrioWorld->addCreature(dog);
	#define WLEFTD WLEFT-24.0
	#define WRIGHTD WRIGHT + 24.0
	#define WFRONTD WFRONT
	
	DogDish *dogdish;
/*	
	myBrioWorld->addCreature
	(dogdish= new DogDish(SbVec3f(WRIGHT, 0, WBACK + 20.0),SbVec3f(10, 2, 10 ),sf));
*/	
	/* right wall */
	Wall *wall;
	
	myBrioWorld->addCreature
	(wall= (new Wall(SbVec2f(WRIGHTD, WFRONTD+25),SbVec2f(WRIGHTD ,WBACK ),WALLH, WALLW, sf)));
	wall->setVisible(0);
	/* left wall */
	myBrioWorld->addCreature
	(wall= (new Wall(SbVec2f(WLEFTD, WFRONTD+25),SbVec2f(WLEFTD ,WBACK ),WALLH, WALLW, sf)));
	wall->setVisible(0);
	/* front wall  */
	myBrioWorld->addCreature
	(wall= (new Wall(SbVec2f(WLEFTD, WFRONTD+25),SbVec2f(WRIGHTD ,WFRONTD+25 ),WALLH, WALLW, sf)));
	wall->setVisible(1);
	/* back wall  
	myBrioWorld->addCreature
	((new Wall(SbVec2f(WLEFTD, 0),SbVec2f(WLEFTD+50 ,0 ),WALLH, WALLW, sf)));
	*/
	
	/* front wall */
	myBrioWorld->addCreature
	(wall= (new Wall(SbVec2f(WLEFTD, WBACK),SbVec2f(WRIGHTD ,WBACK ),WALLH, WALLW, sf)));
	wall->setVisible(0);
 
}















