#include <math.h>
#include <Inventor/SbLinear.h>
#include <Inventor/Sb.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoDB.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/engines/SoElapsedTime.h>
#include <Inventor/engines/SoTimeCounter.h>
#include <Inventor/engines/SoInterpolate.h>
#include <Inventor/engines/SoCalculator.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoPendulum.h>
#include <Inventor/nodes/SoShuttle.h>
#include "MediaCreature.h"
#include "GenericMotorControl.h"


SO_NODE_SOURCE(MediaCreature);



void
MediaCreature::initClass()
{

    SO_NODE_INIT_CLASS(MediaCreature, BehaviorCreature, "BehaviorCreature");
}

MediaCreature::MediaCreature() : BehaviorCreature()
{
    SO_NODE_CONSTRUCTOR(MediaCreature);

    SO_NODE_ADD_FIELD(amIDirty, (FALSE));
    SO_NODE_ADD_FIELD(name,("NoName"));
    SO_NODE_ADD_FIELD(filename,("NoFilename"));
    SO_NODE_DEFINE_ENUM_VALUE(TreeType, LEAF);
    SO_NODE_DEFINE_ENUM_VALUE(TreeType, TWIG);
    SO_NODE_DEFINE_ENUM_VALUE(TreeType, NODE);
    SO_NODE_SET_SF_ENUM_TYPE(treeType, TreeType);
    SO_NODE_ADD_FIELD(treeType,(MediaCreature::LEAF));
    SO_NODE_ADD_FIELD(num_parents,(1.0));		
    SO_NODE_ADD_FIELD(parentList,("noParents"));
	
}


SbBool	
#ifdef SO_VERSION_REVISION
MediaCreature::readInstance(SoInput *in, unsigned short flags) 
#else
MediaCreature::readInstance(SoInput *in) 
#endif
{
#ifdef SO_VERSION_REVISION
  if (BehaviorCreature::readInstance(in, flags))
#else
  if (BehaviorCreature::readInstance(in))
#endif
    return TRUE;
  else
    return FALSE;
}


MediaCreature::~MediaCreature()
{
}
