
#ifndef __MEDIA_CREATURE__
#define __MEDIA_CREATURE__

#include <Inventor/SbPList.h>
#include "BehaviorCreature.h"
#include <Inventor/fields/SoMFBool.h>
#include <Inventor/fields/SoMFNode.h>

class GenericController;
class SoInput;
class SoCamera;
class CarController;

class MediaCreature : public BehaviorCreature {
    SO_NODE_HEADER(MediaCreature);

public:
    static void initClass();

    SoSFString name;
    SoSFString filename;
    SoSFBool amIDirty;
    enum TreeType {LEAF, TWIG, NODE};
    SoSFEnum treeType;
    SoSFFloat num_parents;   
    SoMFString parentList;



protected:
    MediaCreature();           // Note only should be called during a read
#ifdef SO_VERSION_REVISION
    SbBool readInstance(SoInput *in, unsigned short flags);
#else
    SbBool readInstance(SoInput *in);
#endif
    virtual ~MediaCreature();
    
}; 

#endif
