#include <iostream.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <Inventor/SbLinear.h>
#include <Inventor/Sb.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoDB.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/nodekits/SoSeparatorKit.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/engines/SoElapsedTime.h>
#include <Inventor/engines/SoTimeCounter.h>
#include <Inventor/engines/SoInterpolate.h>
#include <Inventor/engines/SoCalculator.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/engines/SoOneShot.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoPendulum.h>
#include <Inventor/nodes/SoShuttle.h>
#include <Inventor/nodes/SoGroup.h>
#include <Inventor/fields/SoMFBool.h>
#include <Inventor/fields/SoMFNode.h>
#include "MediaLeaf.h"
#include "GenericMotorControl.h"
#include "movieFunctions.h"
#include "util.h"
#include "BasicDefines.h"
#include "mediaCreatureActionCallbacks.h"
SO_NODE_SOURCE(MediaLeaf);

extern EngineStarted;

void
MediaLeaf::initClass()
{
    SO_NODE_INIT_CLASS(MediaLeaf, MediaCreature, "MediaCreature");
}

MediaLeaf::MediaLeaf() : MediaCreature()
{
    SO_NODE_CONSTRUCTOR(MediaLeaf);
    SO_NODE_DEFINE_ENUM_VALUE(MediaType, TEXT);
    SO_NODE_DEFINE_ENUM_VALUE(MediaType, IMAGE);
    SO_NODE_DEFINE_ENUM_VALUE(MediaType, ANIMATION);
    SO_NODE_SET_SF_ENUM_TYPE(mediaType, MediaType);
    SO_NODE_ADD_FIELD(mediaType,(MediaLeaf::IMAGE));  
    /*SO_NODE_DEFINE_ENUM_VALUE(Dominance, PREDATOR);
    SO_NODE_DEFINE_ENUM_VALUE(Dominance, PREY);
    SO_NODE_DEFINE_ENUM_VALUE(Dominance, NEUTRAL);
    SO_NODE_SET_SF_ENUM_TYPE(dominance, Dominance);
    SO_NODE_ADD_FIELD(dominance,(MediaLeaf::NEUTRAL));*/
 /*   SO_NODE_DEFINE_ENUM_VALUE(Emotion, NONE);
    SO_NODE_DEFINE_ENUM_VALUE(Emotion, HUNTING);
    SO_NODE_DEFINE_ENUM_VALUE(Emotion, SCARED);
    SO_NODE_SET_SF_ENUM_TYPE(emotion, Emotion);
    SO_NODE_ADD_FIELD(emotion,(MediaLeaf::NONE));*/
    SO_NODE_ADD_FIELD(emotion,(0));
    SO_NODE_ADD_FIELD(dominance,(0));
   
    SO_NODE_ADD_FIELD(motionType,(0));
    SO_NODE_ADD_FIELD(movieListIndex,(0));
    SO_NODE_ADD_FIELD(isMoving,(FALSE));

 }

SbBool	
#ifdef SO_VERSION_REVISION
MediaLeaf::readInstance(SoInput *in, unsigned short flags) 
#else
MediaLeaf::readInstance(SoInput *in) 
#endif
{
#ifdef SO_VERSION_REVISION
  if (MediaCreature::readInstance(in, flags))
#else
  if (MediaCreature::readInstance(in))
#endif
       return TRUE;
   else
    return FALSE;
}
   
void
MediaLeaf::doScale(int type)
{
  SoOneShot * countDown = new SoOneShot;
  countDown->duration = 4.0; 
  countDown->flags.setValue(SoOneShot::HOLD_FINAL);
cerr << "Doing Scale (MediaLeaf Version" << endl;
 /* SoInterpolateVec3f* shrink = new SoInterpolateVec3f;
  shrink->input0.setValue(1.,1.,1.);
  shrink->input1.setValue(0.,0.,0.);
  shrink->alpha.connectFrom(&countDown->ramp);*/
  this->getBodyTransform()->scaleFactor.connectFrom(&countDown->ramp);
  countDown->trigger.touch();
cerr << "Out of Doing Scale " << endl;

}
  
MediaLeaf::~MediaLeaf()
{
}


