#ifndef __MEDIA_LEAF__
#define __MEDIA_LEAF__

#include <Inventor/SbPList.h>
#include "BehaviorCreature.h"
#include "MediaCreature.h"
#include "movieFunctions.h"
#include <Inventor/fields/SoMFBool.h>
#include <Inventor/fields/SoMFNode.h>

class GenericController;
class SoInput;
class SoCamera;
class CarController;

class MediaLeaf : public MediaCreature {
    SO_NODE_HEADER(MediaLeaf);

public:
    static void initClass();
    enum MediaType {TEXT, IMAGE, ANIMATION};
//    enum Dominance {PREDATOR, PREY, NEUTRAL};
    //enum Emotion {NONE,HUNTING,SCARED};
    //SoSFEnum emotion;
    SoSFFloat emotion;
    SoSFFloat dominance;
    SoSFEnum mediaType;
    SoSFFloat motionType;
    SoSFBool isMoving;
    
    SoSFFloat movieListIndex;

    void doScale(int type);
protected:
    MediaLeaf();           // Note only should be called during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool	readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool	readInstance(SoInput *in);
#endif
    virtual ~MediaLeaf();
    
}; 

#endif
