#include <math.h>
#include <Inventor/SbLinear.h>
#include <Inventor/Sb.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoDB.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/nodekits/SoSeparatorKit.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/engines/SoElapsedTime.h>
#include <Inventor/engines/SoTimeCounter.h>
#include <Inventor/engines/SoInterpolate.h>
#include <Inventor/engines/SoCalculator.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoPendulum.h>
#include <Inventor/nodes/SoShuttle.h>
#include <Inventor/nodes/SoGroup.h>
#include <Inventor/fields/SoMFBool.h>
#include <Inventor/fields/SoMFNode.h>
#include "MediaNode.h"
#include "GenericMotorControl.h"


SO_NODE_SOURCE(MediaNode);

void
MediaNode::initClass()
{
    SO_NODE_INIT_CLASS(MediaNode, MediaCreature, "MediaCreature");
}

MediaNode::MediaNode() : MediaCreature()
{
    SO_NODE_CONSTRUCTOR(MediaNode);

      SO_NODE_ADD_FIELD(num_children,(1.0));
      SO_NODE_ADD_FIELD(dirtyList,(0));
      SO_NODE_ADD_FIELD(childList,("noChildren"));
}

SbBool	
#ifdef SO_VERSION_REVISION
MediaNode::readInstance(SoInput *in, unsigned short flags) 
#else
MediaNode::readInstance(SoInput *in) 
#endif
{
#ifdef SO_VERSION_REVISION
  if (MediaCreature::readInstance(in, flags))
#else
  if (MediaCreature::readInstance(in))
#endif
    return TRUE;
  else
    return FALSE;
}
    
MediaNode::~MediaNode()
{
}


