#ifndef __MEDIA_NODE__
#define __MEDIA_NODE__

#include <Inventor/SbPList.h>
#include "BehaviorCreature.h"
#include "MediaCreature.h"
#include <Inventor/fields/SoMFBool.h>
#include <Inventor/fields/SoMFNode.h>

class GenericController;
class SoInput;
class SoCamera;
class CarController;

class MediaNode : public MediaCreature {
    SO_NODE_HEADER(MediaNode);

public:
    static void initClass();
    SoMFBool dirtyList;
    SoSFFloat num_children;
    SoMFString childList; 
    SoSFString motionEngine;

    
protected:
    MediaNode();           // Note only should be called during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool	readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool	readInstance(SoInput *in);
#endif
    virtual ~MediaNode();
    
}; 

#endif
