#include <iostream.h>
#include <assert.h>
#include <Inventor/SbString.h>
#include <Inventor/fields/SoSFString.h>
#include <Inventor/engines/SoOneShot.h>
#include <Inventor/engines/SoInterpolate.h>
#include <Inventor/nodes/SoShuttle.h>

#include "ActivityLib_1.h"
#include "BehaviorCreature.h"
#include "BehaviorPerson.h"
#include "util.h"
#include "BasicDefines.h"
#include "MediaCreature.h"
#include "MediaLeaf.h"
#include "mediaEngineStarter.c++"

#include "BaseBehaviorNode.h"
#include "CreatureRM.h"
#include "CreatureBehavior.h"
#include "LeafActivity.h"
#include "SensorLib.h"
#include "BasicDefines.h"
#include "AliveCamera.h"
#include "Alive.h"


void
stayStill(BaseActivity *act, BehaviorUpdateAction *action)
{
  CBUA(dba,action);
  PRONOME(pronome,dba);
  LeafActivity *la = (LeafActivity *)act;
  MediaLeaf *self = (MediaLeaf *)dba->creature;
  MotorCommandBlock mcb(GC_MOVE_GEN);
  mcb.setNextArgGeneric(ArgType((float)0.0));
  mcb.setNextArgGeneric(ArgType((float).3));
  la->issueMotorCommand(*dba->creature,mcb);
}

void
doReactiveMotionCallback(BaseActivity *act, BehaviorUpdateAction *action)
{

  CBUA(dba,action);
  PRONOME(pronome, dba);
  MediaLeaf *self = (MediaLeaf *)dba->creature;
  SoTexture2 *textureMap = (SoTexture2 *) self->getByName("TextureMap");
cerr << "Got textureMap \n" <<endl;
  textureMap->filename.setValue("../MediaLib/bear.rgb");
cerr << "changed TextureMap\n" << endl;
  
/*  if (self->motionType.getValue() != 0)
    { 
      if (self->isMoving.getValue() == FALSE)
	{
	  startCreatureMotion(self); 
	  self->isMoving.setValue(TRUE);
cerr << "isMoving == TRUE\n" << endl;
	}
    }*/

((BehaviorPerson *)pronome->object)->extendedLeft.setValue(FALSE);
 SoOneShot *countDown = new SoOneShot;
  countDown->duration = 15.0; 
  countDown->flags.setValue(SoOneShot::HOLD_FINAL);
cerr << "Doing Scale" << endl;
  SoInterpolateVec3f* grow = new SoInterpolateVec3f;
  grow->input0.setValue(1.,1.,1.);
  grow->input1.setValue(4.,4.,4.);
  grow->alpha.connectFrom(&countDown->ramp);
  self->getBodyTransform()->scaleFactor.connectFrom(&grow->output);
  countDown->trigger.touch();
cerr << "Out of Doing Scale " << endl;
// self->doScale(0);

}

void followMediaGradient(BaseActivity *act, BehaviorUpdateAction *action)
{
    CBUA(dba, action);
    PRONOME(p, dba);
    PFSENSOR(s, dba);
    static float lastBearing = 0.0;
    
   LeafActivity *la = (LeafActivity *)act;

    float bearing = s->pf->weightedBearing;
    float mg = s->pf->maxGrad;
    float sp = .05;

//    printf("minBearing -> %f maxGradient %f \n",bearing, mg);
    
    bearing = (bearing>1)?1 : bearing;
    bearing = (bearing< -1)?-1 : bearing;

    la->mcb.cmd=GC_TURN_GEN;
    float tmp = (float)(.5 -( bearing/2));
    la->mcb.setNextArgGeneric(tmp);
    sp = (fabs(mg)>1.0)?fabs(mg*mg)*.010 :.010;
    sp = (sp>.06)?.06 : sp;
    la->mcb.setNextArgGeneric(sp);
 la->issueMotorCommand(*dba->creature,la->mcb);
 cerr << "turnMediaTowardMinDensity" << endl;    
    
}

static void turnMediaWithGradient(BaseActivity *act, BehaviorUpdateAction *action)
{
  CBUA(dba, action);
  PRONOME(p, dba);
  PFSENSOR(s, dba);
  static float lastBearing;
  
  LeafActivity *la = (LeafActivity *)act;
  float bearing = s->pf->weightedBearing;
  float mg = s->pf->maxGrad;
  float sp = .05;
  bearing = (bearing>.2)?.2 : bearing;
  bearing = (bearing< -.2)?-.2 : bearing;
  bearing = ((bearing < 0.001)&&(bearing>-0.001))?0.1:bearing;
 if(!dba->creature->checkIfReadyToMove(la->mcb))
    return; 
 if (bearing == lastBearing){
    la->mcb.cmd = GC_HEADTOWARD;
    la->mcb.setNextArgGeneric((float)0);
    la->mcb.setNextArgGeneric((float)0);
    la->mcb.setNextArgGeneric((float)0);
    la->issueMotorCommand(*dba->creature,la->mcb);
    return; 
  }
  lastBearing = bearing;
  la->mcb.cmd = GC_TURN_GEN;
  int tmp = rand()%2;
  if (tmp == 0) 
    {
      la->mcb.setNextArgGeneric(-bearing);
    }
  else 
    {
      la->mcb.setNextArgGeneric(bearing);
    }
sp = (fabs(mg)>1.0)?fabs(mg*mg)*.010 :.010;
    sp = (sp>.3)?.3 : sp; 
  la->mcb.setNextArgGeneric(sp);
  la->issueMotorCommand(*dba->creature,la->mcb);
}


void turnMediaTowardMinDensityCallback(BaseActivity *act, BehaviorUpdateAction *action)
{
    CBUA(dba, action);
    PRONOME(pronome, dba);
    PFSENSOR(s, dba);
//    CHECKPRONOME(pronome);
    
    LeafActivity *la = (LeafActivity *)act;
    float bearing; 
    
    if(!dba->creature->checkIfReadyToMove(la->mcb)){
//	gazeAtObjectOfInterest(pronome->bearing, act, action);
	return;
    }
//    followGaitSuggestion(act, action);
    // experimental gaze stuff
    s->updateGradient();
    bearing = s->pf->weightedBearing;
    pronome->location[0] = cos(.6*bearing)*30.0;
    pronome->location[1] = -5.0;
    pronome->location[2] = sin(.6*bearing)*30.0;

    pronome->location = s->getVecInWorldFrame(pronome->location);
    followMediaGradient(act, action);
}


static void turnMediaAwayCB(BaseActivity *act, BehaviorUpdateAction *action)
{
  CBUA(dba, action);
  PFSENSOR(s, dba);
  LeafActivity *la = (LeafActivity *)act;
  
  if(!dba->creature->checkIfReadyToMove(la->mcb))
    return;
  s->updateGradient();
cerr << "**Avoiding Wall!! \n" << endl;
  turnMediaWithGradient(act, action);
}






static void startHunting(BaseActivity *act, BehaviorUpdateAction *action)
{
  CBUA(dba,action);
  PRONOME(p,dba);
  MediaLeaf *self = (MediaLeaf*)dba->creature;

  float oldHeading = self->getHeading();
  SoOneShot *timeRot = new SoOneShot;
  timeRot->duration.setValue(1.0);
  timeRot->flags.setValue(SoOneShot::HOLD_FINAL);
  SoInterpolateRotation *rot = new SoInterpolateRotation;
 
  rot->input0.setValue(self->getBodyTransform()->rotation.getValue());
  rot->input1.setValue(0,0,1,1.44159265);
  rot->alpha.connectFrom(&timeRot->ramp);
  timeRot->trigger.touch();
//  self->emotion.setValue(MediaLeaf::HUNTING);
  self->getBodyTransform()->rotation.connectFrom(&rot->output);
  self->setHeading(oldHeading);
}

static void wanderCB(BaseActivity *act, BehaviorUpdateAction *action)
{

  static int timesCalled;
    static int currCmd = GC_MOVE_GEN;

    static count = 0;
    static val = 0;
  
    CBUA(dba, action);
    PFSENSOR(s, dba);
    LeafActivity *la = (LeafActivity *)act;
    if(!dba->creature->checkIfReadyToMove(la->mcb))
	return;
    else {

/*    if (count == 0) {
	val = rand() / 10923;
	if (val == 0) {
		count = rand() / 1638; // do for a max of 20 times
	} else {
		count = rand() / 3276; // do for a max of 10 times
	}
    } else {
	count--;
    }*/
    val = rand()%9;
    if (val < 5){val = 0;}
    else if (val > 7){val=1;}
    else {val = 2;}
	
    float tmp;

    switch (val) {
	case 0:
	    la->mcb.cmd = GC_MOVE_GEN;
	    tmp = dba->creature->defaultFwdSpeed.getValue();
	    val = rand()%5;
	    if (val > 2)
		tmp += val;
	    else 
		tmp -= val;
	    la->mcb.setNextArgGeneric((float)tmp);
	    la->mcb.setNextArgGeneric((float)1.0);
	    break;	
	case 1:
	    la->mcb.cmd = GC_TURN_GEN;
	    val = rand()%2;
	    if (val == 0)
	      tmp = .2;
	    else
	      tmp = -.2;
	    la->mcb.setNextArgGeneric((float)tmp);
	    la->mcb.setNextArgGeneric((float)1);
	    break;	
	case 2:
	    la->mcb.cmd = GC_MOVE_GEN;
            la->mcb.setNextArgGeneric((float)0.0);
  	    la->mcb.setNextArgGeneric((float)1.0);   
	 break;	
    }
  la->issueMotorCommand(*dba->creature,la->mcb);

   }  

}

static void followPronomeCB(BaseActivity *act, BehaviorUpdateAction *action)
{
  CBUA(dba, action);
  PRONOME(p, dba);
  LeafActivity *la = (LeafActivity *)act;
  
  if(!dba->creature->checkIfReadyToMove(la->mcb))
    return;

  if (p && p->status == Pronome::PASSEDFILTER)
    {
      SbVec3f pos; 
      dba->creature->getPosition(pos);
      SbVec3f heading;
      dba->creature->getHeading(heading);
      SbVec3f delta = pos - p->location;
      //  if(((MediaLeaf*)dba->creature)->emotion.getValue()==MediaLeaf::NONE)
      //	{//cerr << "starting the HUNT" << endl;
      //  startHunting(act,action);
      //	}
      //    else
      //	{
      // Project into x-z plane
      heading.setValue(heading[0],0.0,heading[2]);
      delta.setValue(delta[0],0.0,delta[2]);
      heading.normalize();
      delta.normalize();
      float dot = heading.dot(delta);
      if (fabs(1.0-dot) > .1)   // turn towards pronome
	{
	  MotorCommandBlock mcb(GC_TURN_GEN);
	  //      la->mcb.cmd = GC_TURN_GEN;
	  float cross = -heading.cross(delta)[1]; // Take y component.
	  mcb.setNextArgGeneric(ArgType((float)cross));
	  mcb.setNextArgGeneric(ArgType((float)0.2));
	  la->issueMotorCommand(*dba->creature,mcb);
	}
      else // go straight
	{
	  MotorCommandBlock mcb(GC_TURN_GEN,ArgType((float)0.0),
				ArgType((float)0.1));
	  la->issueMotorCommand(*dba->creature,mcb);
	}
    }
  la->mcb.cmd = GC_MOVE_GEN;
//  la->mcb.setNextArgGeneric((float)8.0);
  la->mcb.setNextArgGeneric((float)dba->creature->defaultFwdSpeed.getValue()+((MediaLeaf *)dba->creature)->emotion.getValue());
  la->mcb.setNextArgGeneric((float)1);
  //  }
}

void
displayContentCallback(BaseActivity *act, BehaviorUpdateAction *action)
{
  CBUA(dba, action);
  PRONOME(pronome, dba);
  MediaCreature *self = (MediaCreature *)dba->creature;
/*   ****** Callback disabled to permit changeover to
  MediaCreature --> {MediaNode MediaLeaf} system  -richlach 7/16  
  switch (self->mediaType.getValue())
    {
    case MediaCreature::TEXT:
      // code for displaying text
      cerr << "Display text: " << self->filename.getValue().getString() << endl;
      break;

    case MediaCreature::IMAGE:
      // code for displaying picture
      cerr << "Display picture: " << self->filename.getValue().getString() << endl;
      break;

    case MediaCreature::ANIMATION:
      // code for displaying animation
      cerr << "Display animation: " << self->filename.getValue().getString() << endl;
      break;
    }
*/
}

void initMediaCreatureActionCallbackList()
{
  BaseBehaviorNode::addCallback("showContent", displayContentCallback);
  BaseBehaviorNode::addCallback("doReactiveMotion",doReactiveMotionCallback);
  BaseBehaviorNode::addCallback("followClosestCreature",followPronomeCB);
  BaseBehaviorNode::addCallback("stayStill",stayStill);
  BaseBehaviorNode::addCallback("wanderAround",wanderCB);
  BaseBehaviorNode::addCallback("turnMediaAway",turnMediaAwayCB);
  BaseBehaviorNode::addCallback("turnMinDensity",turnMediaTowardMinDensityCallback);
 
}


