#include <iostream.h>
#include <stdio.h>
#include <assert.h>
#include <Inventor/SbString.h>
#include <Inventor/SbBasic.h>
#include <Inventor/fields/SoSFBool.h>
#include <Inventor/fields/SoSFString.h>
#include <Inventor/nodes/SoShuttle.h>
#include <Inventor/nodes/SoPendulum.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/engines/SoTimeCounter.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/engines/SoInterpolate.h>
#include <Inventor/engines/SoBoolOperation.h>

#include "ActivityLib_1.h"
#include "BehaviorCreature.h"
#include "util.h"
#include "BasicDefines.h"
#include "MediaCreature.h"
#include "MediaLeaf.h"


void
startCreatureMotion(MediaLeaf *s) {

  float x, y, z, t;
  SbVec3f temp;
  s->getPosition(temp);
  temp.getValue(x, y, z);
  //assert((x==0) && (y==0) && (z==0) );
  SoSFFloat motion =  s->motionType;
 
 		// Waddle.
	if (motion.getValue() == 1.0)
   	  {
   		SoPendulum *cPendulum = new SoPendulum;
   		cPendulum->rotation0.setValue(0, 0, 1, -3.44159265);
   		cPendulum->rotation1.setValue(0, 0, 1, 3.44159265);
   		cPendulum->speed = .5;
		s->getBodyTransform()->rotation.connectFrom(&cPendulum->rotation);
		
  		SoShuttle *walk = new SoShuttle;
  		walk->translation0.setValue(temp);
			// We can change this value to person position.
                z -= 80;
  		walk->translation1.setValue(x, y, z); 
  		walk->speed = .1;
		s->getBodyTransform()->translation.connectFrom(&walk->translation);

       	  }


		// Smoother jump.
	else if (motion.getValue() == 2.0)
	  {
		SoShuttle *jumpHeight = new SoShuttle;
		SoShuttle *jumpWidth = new SoShuttle;
		SoBoolOperation *startup = new SoBoolOperation;
		SoInterpolateVec3f *jump = new SoInterpolateVec3f;
		jumpHeight->translation0.setValue(temp);
                t = y;
		y += 30;
		jumpHeight->translation1.setValue(x, y, z);
		jumpHeight->speed = 1.0;
   		jumpHeight->on.connectFrom(&startup->output);
		jumpWidth->translation0.setValue(temp);
                x += 80;
		jumpWidth->translation1.setValue(x, t, z);
		jumpWidth->speed = .05;
		jumpWidth->on.connectFrom(&startup->output);
		jump->input0.connectFrom(&jumpHeight->translation);
		jump->input1.connectFrom(&jumpWidth->translation);
		jump->alpha = .5;
		s->getBodyTransform()->translation.connectFrom(&jump->output);
		startup->a = (SbBool) TRUE;
		startup->operation = SoBoolOperation::A;

	  }
		// Slither.
	else if (motion.getValue() == 3.0)
	  {
   		SoPendulum *cPendulum = new SoPendulum;
   		cPendulum->rotation0.setValue(0, 1, 0, -3.44159265);
   		cPendulum->rotation1.setValue(0, 1, 0, 3.44159265);
   		cPendulum->speed = 1.0;
		s->getBodyTransform()->rotation.connectFrom(&cPendulum->rotation);

		SoShuttle *slitherHeight = new SoShuttle;
		SoShuttle *slitherWidth = new SoShuttle;
		SoInterpolateVec3f *slither = new SoInterpolateVec3f;
		slitherHeight->translation0.setValue(temp);
		t = z;
 		z -= 30;
		slitherHeight->translation1.setValue(x, y, z);
		slitherHeight->speed = 1.0;
		slitherWidth->translation0.setValue(temp);
		x += 80;
		slitherWidth->translation1.setValue(x, y, t);
		slitherWidth->speed = .08;
		slither->input0.connectFrom(&slitherHeight->translation);
		slither->input1.connectFrom(&slitherWidth->translation);
		slither->alpha = .5;
		s->getBodyTransform()->translation.connectFrom(&slither->output);

	  }
		// Wavy
//	else if (motion.getValue() == 4.0)
//          {

} /* end startCreatureMotion */





