#include <stdlib.h>
#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <Inventor/fields/SoSFImage.h>
#include <Inventor/SbLinear.h>
#include <Inventor/nodes/SoTexture2.h>

#include "movieFunctions.h"

// This is a cheesy version that doesn't deal with rgb guts.
// DO NOT uncomment the stuff in NOTES.  It's meant for Mentor type junk.

/////////////////////////////////////////////////////////////////////////
// NOTES:
//
// The stuff that needs to come before your main() is:
//
//
//   // GLOBAL VARIABLES THAT MUST BE USED IN main()
//MovieFrame *movie, *currframe;
//   
//   // THE SENSOR CALLBACK THAT CHANGES THE FRAMES
//static void
//frameChangeSensorCallback( void *data, SoSensor *)
//{
//   // Go to next frame of movie 
//
//   SoTexture2 *faceTexture = (SoTexture2 *)data;  
//
//   MovieFrame *tempframe;
//   if(currframe->getNext() != NULL) {
//   	tempframe = currframe->getNext();
//   }
//   else {
//	tempframe = movie->getNext();
//   }
//   currframe = tempframe;
//
//  faceTexture->image.connectFrom(&(currframe->getTexture())->image);
//   
//}
//**********************************************************************
// The stuff that needs to appear in your main() is:
//
// //[THESE CAN BE READ FROM COMMAND LINE ARGS]
//
//   int firstframe;
//   int lastframe;
//   char *title;
//   firstframe = 1;
//   lastframe = 30;
//   title = "/mas/vision/guests/cchao/video/woman/mywomanVideo";
//
// 
// //[THIS APPEARS AFTER INITIALIZING ROOT]
//
//   // Creates the global movie pointer and loads the frames into linked list
//   movie = new MovieFrame;
//   doMovieProcessing( movie, firstframe, lastframe, title );
//   
//   // This is a global marker to point at the current frame being shown 
//   currframe = movie->getNext();
//
//   SoTexture2 *faceTexture = new SoTexture2;
//   root->addChild(faceTexture);
//
//   // Set up the timer sensor
//   SoTimerSensor *frameChangeSensor = new SoTimerSensor(frameChangeSensorCallback, faceTexture);
//   frameChangeSensor->setInterval(0.15); // plays 15 frames per second
//   frameChangeSensor->schedule();
//
/////////////////////////////////////////////////////////////////////////


class MovieFrame;

//*********************************************************************
// Function: addNewFrame
// Purpose: Given a MovieFrame pointer and a filename, this function
// loads the file texture into memory and links this new texture or
// movie frame to the MovieFrame pointer.  

void
addNewFrame( MovieFrame *currframe, char *filename )
{
	MovieFrame* newFrame = new MovieFrame;
	SoTexture2* newTexture = new SoTexture2;
	
        newTexture->filename.setValue(filename);
        newFrame->putTexture(newTexture);
	currframe->putNext(newFrame);	 

}

//*********************************************************************
// Function: doMovieProcessing()
// Purpose: This loads all the movie frames (textures) into Inventor
// memory when an application starts up, hopefully speeding up
// playback time in the environment.  Right now only a single movie
// will be loaded (150 frames). 

void
doMovieProcessing( MovieFrame *tMovie, int firstFrame, int lastFrame,
                   char* title )
{
   char frameFilename[50];
   char number[5];
   MovieFrame *currentFrame;
  
   currentFrame = tMovie;

   for( int count = firstFrame; count <= lastFrame; count++ ) {
        if(count<=9) sprintf(number,"0%d",count);
        if(count>9 && count<100) sprintf(number,"%d",count);
        //if(count>=100) sprintf(number,"%d",count);
        
	sprintf(frameFilename, "%s.%s", title, number);
	
	addNewFrame( currentFrame, frameFilename );

        if( count == firstFrame ) {
	   tMovie = tMovie->getNext();
        }
        else {
	   currentFrame = currentFrame->getNext();
	   if( count == lastFrame )
                currentFrame->putNext(NULL);  // end linked-list
        }
   }
 
  
}  /* end doMovieProcessing */










