#ifndef _DISTRIBUTED_SWITCH_
#define _DISTRIBUTED_SWITCH_

#include <Inventor/SbBasic.h>
#include <Inventor/SoInput.h>
#include <Inventor/actions/SoAction.h>
#include <Inventor/actions/SoGLRenderAction.h>
#include <Inventor/fields/SoSFEnum.h>
#include <Inventor/nodes/SoGroup.h>

class DistributedSwitch : public SoGroup {

  SO_NODE_HEADER(DistributedSwitch);

public:
  enum MotorCreatureType {
    MASTER,
    DROID
    };
  
  SoSFEnum showFor;
  
  DistributedSwitch();
  static void initClass();
  
protected:
  virtual ~DistributedSwitch();
#ifdef SO_VERSION_REVISION
  SbBool readInstance(SoInput *in, unsigned short flags);
#else
  SbBool readInstance(SoInput *in);
#endif
  virtual void doAction(SoAction *action);
  virtual void GLRender(SoGLRenderAction *action);
//  virtual void handleEvent(SoHandleEventAction *action);
  int showChildren;
};

#endif
