#ifndef _MOREBASIC_SKILLS_
#define _MOREBASIC_SKILLS_

#include <stdio.h>
#include "MotorSkill.h"
#include <Inventor/SbLinear.h>
#include <Inventor/SbPList.h>
#include <Inventor/SbString.h>
#include "RepSwitch.h"
/**********************************************************************
 *
 * will call resetCB if any declared for creature
 *  arg 0 - name of field (char *)
 *  arg 1 - value (SbVec3f,int, or float)
 *
 **********************************************************************/
 
class ResetAction: public MotorSkill {
  public:

    ResetAction(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

/**********************************************************************
 *
 *  arg 0 - id of new rep
 * 
 *
 **********************************************************************/

class ChangeRep: public MotorSkill {
  public:
    ChangeRep(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

/**********************************************************************
 *
 * set vec field and set bool field
 *  arg 0 - name of field (char *)
 *  arg 1 - value (SbVec3f,int, or float)
 *
 **********************************************************************/

class SetVecField: public MotorSkill {
  public:

    SetVecField(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

class SetBoolFieldGeneric: public MotorSkill {
  public:

    SetBoolFieldGeneric(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

class SetFloatFieldGeneric: public MotorSkill {
  public:

    SetFloatFieldGeneric(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

/***************************************************************
 * All of the following mutators are of the following form:
 * arg0 : name of node (char *)
 * arg1 : name of field (char *)
 * arg2 : value (SbVec3f, int, or float)
 * arg3 : creature variable (0) or behavior variable (1) (int)
 ***************************************************************/
class SetVecFieldInNamedNode: public MotorSkill {
  public:

    SetVecFieldInNamedNode(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

class SetBoolFieldInNamedNode: public MotorSkill {
  public:

    SetBoolFieldInNamedNode(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

class SetFloatFieldInNamedNode: public MotorSkill {
  public:

    SetFloatFieldInNamedNode(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};


/**********************************************************************
 *
 * get vec field or get bool field and print on stdout
 *  arg 0 - name of field
 *
 **********************************************************************/
class GetVecField: public MotorSkill {
  public:

    GetVecField(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

class GetBoolFieldGeneric: public MotorSkill {
 public:
  
  GetBoolFieldGeneric(MotorCreature *,char *);
  void updateImmediate(void *);
};

class GetFloatFieldGeneric: public MotorSkill {
  public:

    GetFloatFieldGeneric(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

/***************************************************************
 * All of the following observers are of the following form:
 * arg0 : name of node (char *)
 * arg1 : name of field (char *)
 * arg2 : flag whether is creature variable (0) or behavior variable (1) (int)
 ***************************************************************/
class GetVecFieldInNamedNode: public MotorSkill {
  public:

    GetVecFieldInNamedNode(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

class GetBoolFieldInNamedNode: public MotorSkill {
  public:

    GetBoolFieldInNamedNode(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

class GetFloatFieldInNamedNode: public MotorSkill {
  public:

    GetFloatFieldInNamedNode(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
    
};

/*
 *  GetBoolFields: returns state of boolean fields
 */
class GetBoolFields: public MotorSkill {
    public:
    GetBoolFields(MotorCreature *p, char *pname);
    void updateImmediate(void *arg);
};
#endif

