#include <stdio.h>

#include <Inventor/Sb.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoDB.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoRotation.h>
#include <Inventor/nodes/SoBaseColor.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoPickStyle.h>
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/SoPath.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/actions/SoGLRenderAction.h>
#include <Inventor/SoOffscreenRenderer.h>
#include <Inventor/SoPickedPoint.h>
#include <Inventor/actions/SoRayPickAction.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoLightModel.h>
#include <Inventor/nodes/SoDrawStyle.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoCallback.h>
#include <Inventor/nodes/SoSwitch.h>
#include <Inventor/fields/SoSFNode.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>
#include <Inventor/elements/SoCacheElement.h>
#include "CamSensor.h"
#include <GL/gl.h>
/*********************************************************************
 * 
 *	    CamSensor  Class
 * 
 *********************************************************************/


SO_NODE_SOURCE(CamSensor);

void
CamSensor::initClass()
{
    SO_NODE_INIT_CLASS(CamSensor, BaseSensor, "BaseSensor");
}

CamSensor::CamSensor() : BaseSensor()
{
    SO_NODE_CONSTRUCTOR(CamSensor);
    SO_NODE_ADD_FIELD(sensorAxis, (0, 1, 0));
    SO_NODE_ADD_FIELD(sensorDir, (1, 0, 0));
    SO_NODE_ADD_FIELD(size,  (64, 64));
    SO_NODE_ADD_FIELD(show, (TRUE));
    camera = NULL;
    ra = NULL;
}

CamSensor::~CamSensor()
{
}


SbBool	
#ifdef SO_VERSION_REVISION
CamSensor::readInstance(SoInput *in, unsigned short flags) 
#else
CamSensor::readInstance(SoInput *in) 
#endif
{
#ifdef SO_VERSION_REVISION
    if (BaseSensor::readInstance(in, flags)) {
#else
    if (BaseSensor::readInstance(in)) {
#endif
	return (1);
    }
    else {
	return(0);
   }
}

void CamSensor::_updateStateAt(UpdateStateData &usd)
{
    int i;
    static int ft = 1;
    if(!ra){
	SbVec2f vpsize = size.getValue();
	SbViewportRegion vp;
	vp.setWindowSize(SbVec2s(vpsize[0], vpsize[1]));
	ra = new SoXtExaminerViewer();
	SoSeparator *sep = new SoSeparator;
	
	sep->addChild(camera = new SoPerspectiveCamera());
	sep->addChild((SoSeparator *)usd.currSceneGraph);
	
	ra->setSceneGraph(sep);
	((SoXtExaminerViewer *)ra)->setDecoration(FALSE);
	ra->setAutoRedraw(show.getValue());
	ra->setSize(SbVec2s(vpsize[0], vpsize[1]));
	ra->show();
    }
    if(camera != NULL){
	SbLine camdata(SbVec3f(0, 0, 0), sensorDir.getValue());
	wXl.multLineMatrix(camdata, camdata);
	camera->position.setValue(camdata.getPosition());
	camera->pointAt(camdata.getPosition()+ camdata.getDirection());
    }
    return;
}

