#ifndef _CAMSENSOR_
#define _CAMSENSOR_

#include <Inventor/SbBasic.h>
#include <Inventor/SbLinear.h>
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/fields/SoSFFloat.h>
#include <Inventor/sensors/SoFieldSensor.h>
#include <Inventor/fields/SoMFVec3f.h>
#include <Inventor/fields/SoSFVec2f.h>
#include <Inventor/fields/SoSFInt32.h>
#include <Inventor/fields/SoMFNode.h>
#include <Inventor/fields/SoSFNode.h>
#include <Inventor/fields/SoSFBool.h>
#include <Inventor/nodes/SoTransform.h>
#include "BaseSensor.h"
#include <Inventor/SbColor.h>
class SoPath;
class SoSwitch;
class SoCamera;

class CamSensor: public BaseSensor {
    SO_NODE_HEADER(CamSensor);

public:
    SoSFVec3f sensorAxis;
    SoSFVec3f sensorDir;
    SoSFVec2f size;
    SoSFBool show;
    SoXtRenderArea *ra;
    
    static void initClass();
    virtual void _updateStateAt(UpdateStateData &usd); // over-ride this method

protected:
    SoCamera *camera;
    CamSensor();       // Note only should be call during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool	readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool	readInstance(SoInput *in);
#endif
    virtual ~CamSensor();

};

#endif

