#ifndef _DEPTHMAPSENSOR_
#define _DEPTHMAPSENSOR_

#include <Inventor/SbBasic.h>
#include <Inventor/SbLinear.h>
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/fields/SoSFFloat.h>
#include <Inventor/sensors/SoFieldSensor.h>
#include <Inventor/fields/SoMFVec3f.h>
#include <Inventor/fields/SoSFVec2f.h>
#include <Inventor/fields/SoSFInt32.h>
#include <Inventor/fields/SoMFNode.h>
#include <Inventor/fields/SoSFNode.h>
#include <Inventor/fields/SoSFBool.h>
#include <Inventor/SbPList.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/SbColor.h>
#include <Inventor/SbTime.h>
#include "CamSensor.h"

class SoPath;
class SoSwitch;
class SoCamera;

class DepthData {
    public:
    SbBool fnd;
    SbVec2f xyn;
    SbVec3f xyz;
};

class DepthMapSensor: public CamSensor {
    SO_NODE_HEADER(DepthMapSensor);

public:
    static void initClass();
    virtual void _updateStateAt(UpdateStateData &usd); // over-ride this method
    void genDepthDataAt(int h, int w, unsigned char *data);
    DepthData *depthData;
protected:
    DepthMapSensor();       // Note only should be call during a read
#ifdef SO_VERSION_REVISION
    virtual SbBool	readInstance(SoInput *in, unsigned short flags);
#else
    virtual SbBool	readInstance(SoInput *in);
#endif
    virtual ~DepthMapSensor();

};

#endif

