#ifndef _POTENTIALFIELD_
#define _POTENTIALFIELD_

#include "SensorLib.h"
class Matrix;
class SoSeparator;
class SoLineSet;
class SoCoordinate3;
class SoXtExaminerViewer;

class PotentialField {
    public:
    float decay;    // amt potential decreases by each cell away from center
    int depth;
    int width;
    Matrix *pfield;
    Matrix *gradMag;
    Matrix *grad;
    
    float weightedBearing;
    float maxGrad;
    
    // graphics stuff
    SoSeparator *visualizer;
    SoCoordinate3 *coords;
    SoCoordinate3 *coords1;
    SoLineSet *lines;
    
    PotentialField(int dimX, int dimZ);
    PotentialField(int dimx, int dimz, float decayAmt);
    void clear();
    void addPotentialField(Matrix &pf1);
    void scalePotentialField(float ns);
    
    void addGradient(Matrix &pg1);
    void addPotentialFieldAtOffset(Matrix &pf1, int d, int w);
    void addGradientAtOffset(Matrix &grad1, int d, int w);
    
    SbBool spreadPotential(SbVec3f lpt, int potential);
    
    void doGradient();
    float doWeightedBearing(int start, int end);
    
    private:
    void commonInit(int dimx, int dimz, float decayAmt);
    void buildVisualizer();
    float convolveMaskAt(Matrix &mask, int d, int w, int skipr, int skipc);
    float convolveMaskAt(Matrix &mask, int x, int y);
    //void spreadPotential(int seedx, int seedy, int pvalue);
    void _spreadPotential(SbBool ifAttractor, 
	int seedx, int seedy, int pvalue, int iter);
    
};

#endif

