#ifndef _VECLIST_
#define _VECLIST_
#include <Inventor/SbLinear.h>
#include <stdlib.h>

class SbVec2Link
{
 public:
  SbVec2Link *next;
  SbVec2s vec;
  
  SbVec2Link(SbVec2s vs) { next = 0; vec = vs; }
  virtual ~SbVec2Link() {delete next; }
};

class SbVec2List
{
 public:
  SbVec2Link *head, *tail;
  int length;
  
  SbVec2List() {
    length = 0;
    head = tail = 0;
  }
  
  virtual ~SbVec2List() {
    delete head; // this will delete every node
  }
  
  void add(SbVec2s vs) {
    if (head) {
      tail->next = new SbVec2Link(vs);
      tail = tail->next;
      length++;
    }
    else {
      head = tail = new SbVec2Link(vs);
      length = 1;
    }
  }
  
  void *remove(SbVec2Link *whichOne);
  void *removeHead(){return remove(head);
  
  void empty();
  
};
#endif
