#ifndef __DLIST__
#define __DLIST__

#include "Dlink.h"
#include "Dlist_base.h"
#include "Dlist_base_iter.h"

template<class T>
struct Tlink : public Dlink {
  T info;
  Tlink(const T& a) : info(a) { }
};

template<class T> class Dlist_iter;

template<class T>
class Dlist : private Dlist_base {
  friend class Dlist_iter<T>;
 public:
  void insert(const T& a);
  void append(const T& a);
  T get();
};

template<class T>
class Dlist_iter : private Dlist_base_iter
{
 public:
  Dlist_iter(Dlist<T>& d) : Dlist_base_iter(d) { }
  T* prev();
  T* next();
  void ffwd();
  void rewind();
  int deleteCurrentElement();
};

#endif
