#include <iostream.h>
#include "Dlist_base.h"

void Dlist_base::insert(Dlink *a)  // add before head of list
{
  if (head)
    {
      a->next = head;
      head->prev = a;
      a->prev = 0;
      head = a;
    }
  else
    {
      head = tail = a;
      a->next = a->prev = 0;
    }
}

void Dlist_base::append(Dlink *a)  // add after end of list
{
  if (tail)
    {
      tail->next = a;
      a->prev = tail;
      a->next = 0;
      tail = a;
    }
  else
    {
      head = tail = a;
      a->next = a->prev = 0;
    }
}

void Dlist_base::deleteElement(Dlink *a)  // delete element in list
{
  if (a != head)
    {
      a->prev->next = a->next;
    }
  else
    {
      head = a->next;
      if (head)	
	head->prev = 0;
      else
	tail = 0;
      delete a;
      return;
    }
  if (a != tail)
    {
      a->next->prev = a->prev;
    }
  else
    {
      tail = a->prev;
      if (tail)
	tail->next = 0;
      else
	head = 0;
      delete a;
      return;
    }
  delete a;
}

Dlink* Dlist_base::get()  // return and remove head of list
{
  if (head == 0)
    {
      cerr << "get from empty Dlist" << endl;
      return 0;
    }
  else
    {
      Dlink *f = head;
      if (f == tail)
	{
	  head = tail = 0;
	}
      else
	head = f->next;
      return f;
    }
}
