#include "Dlist_base_iter.h"

Dlist_base_iter::Dlist_base_iter(Dlist_base& d)
{
  cl = &d;
  headtemp = new Dlink;
  headtemp->prev = 0;
  headtemp->next = cl->head;
  tailtemp = new Dlink;
  tailtemp->next = 0;
  tailtemp->prev = cl->tail;
  ce = headtemp;
}

void Dlist_base_iter::renew()   // call after deletions
{
  headtemp->prev = 0;
  headtemp->next = cl->head;
  tailtemp->next = 0;
  tailtemp->prev = cl->tail;
}  

Dlink* Dlist_base_iter::next()
  // return 0 to indicate end of iteration
{
  Dlink *ret = ce ? ( ce->next ? (ce = ce->next) : 0 ) : 0;
  return ret;
}

Dlink* Dlist_base_iter::prev()
  // return 0 to indicate end of iteration
{
  Dlink *ret = ce ? (ce->prev ? (ce = ce->prev) : 0 ) : 0;
  return ret;
}

void Dlist_base_iter::ffwd()
{
  renew();
  ce = tailtemp;
}

void Dlist_base_iter::rewind()
{
  renew();
  ce = headtemp;
}

int Dlist_base_iter::deleteCurrentElement()
{
  Dlink* ptr;

  if (ce == headtemp || ce == tailtemp)
    return 0;
  if (ce != cl->tail)
    {
      ptr = ce->next;
      cl->deleteElement(ce);
      ce = ptr;
      renew();
    }
  else
    {
      cl->deleteElement(ce);
      renew();
      ce = tailtemp;
    }
  return 1;
}
