// GenericSharedMemoryServer.c++
// This compiles to "your_exec" in the
// example program "GenericSharedMemoryServerStub.c++".
// kbrussel@media.mit.edu

#define _BSD_SIGNALS
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>
#ifdef __GNUG__
#include "Dlist.c++"
#endif
#include "SemaphoreServer.h"

// Take a fast look at this one line file

#include "GenericSharedMemoryServer.h"

SemaphoreServer *ss;

// This is the data type that you will exchange with the
// other thread via shared memory.
typedef void your_data_type;

void
cleanup(...)
{
  delete ss;

  cerr << "shared memory server cleaned up" << endl;
  exit(1);
}

int
main(int argc, char **argv)
{
  your_data_type *ydtemp;

  // This is important when using shared memory segments.
  signal(SIGINT, cleanup);
  
  // Start the SemaphoreClient
  ss = new SemaphoreServer(SHARED_MEMORY_ID, sizeof(your_data_type));
  
  // Initialize the ydtemp pointer
  ydtemp = (your_data_type *) ss->swapBuffers();

  // Go into main loop
  while(!ss->getDieFlag())
    {
      generate_your_data(ydtemp);

      // The next line blocks if the SemaphoreClient is reading the buffer
      ydtemp = (your_data_type *) ss->swapBuffers();
    }
  
  cerr << "Semaphore server caught dieFlag" << endl;
  fflush(stderr);
  cleanup();
}

