// sctest1.c++
// Tests multiple connections to the server and
// deliberately tests a failed connection.
// Requires modification to SocketClient.h to compile
// and run.
// Only works with a TCP server.

#include <iostream.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <unistd.h>
#ifdef __GNUG__
#include "Dlist.c++"
#include "SocketMan.h"
#endif
#include "SocketClient.h"
#include "sockettests.h"

char* server_name;

int main(int argc, char **argv)
{
  SocketClient sc(port, 1, 0, 1, 0);
  int counter = 0;
  int foo;
  int first;
  int numbytes = 64;
  char type = SOCKET_CHAR;
  char garbage[32];

  if (argc == 2)
    {
      server_name = argv[1];
    }
  else
    {
      cerr << "usage: sctest1 <server name>" << endl;
      exit(1);
    }

  // open multiple connections

  while (counter < 3)
    {
      foo = sc.connectToServer(server_name);
      if (sc.serverUsingUDP())
	{
	  cerr << "Error: sctest1 only works on TCP sockets" << endl;
	  exit(1);
	}
      if (foo == 0 && !counter)
	{
	  first = sc.current_socket->fd;
	}
      if (foo == 0)
	counter++;
      sleep(2);
    }

  // let's screw up the server and watch it deal
  
  // tell it that 64 bytes are coming

  numbytes = htonl(numbytes);
  write(first, (void *) &numbytes, 4);
  numbytes = ntohl(numbytes);

  // of data type character

  write(first, (void *) &type, 1);

  // but only write 32

  write(first, (void *) garbage, 32);

  // shut down connection unexpectedly

  close(first);

  // open even more connections

  while (counter < 6)
    {
      foo = sc.connectToServer(server_name);
      if (foo == 0)
	counter++;
      sleep(2);
    }
}
