// sctest2.c++
// Tests timeout facility of server.
// Requires modification of SocketClient.h to compile and run.
// Only works with TCP sockets.

#include <iostream.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#ifdef __GNUG__
#include "Dlist.c++"
#include "SocketMan.h"
#endif
#include "SocketClient.h"
#include "sockettests.h"

char* server_name;

void
slowWrite(int fd, void *ptr, int numbytes)
{
  int counter;

  for (counter = 0; counter < numbytes; counter++)
    {
      write(fd, (void *) ((unsigned char *)ptr + counter), 1);
      cerr << "wrote a byte" << endl;
      sleep(1);
    }
}

int main(int argc, char **argv)
{
  int counter = 0;
  int foo;
  int numbytes;
  char data_type = 0;

  if (argc != 3)
    {
      cerr << "Usage: sctest2 <server name> <word to send>" << endl;
      exit(1);
    }

  SocketClient *sc = new SocketClient(port, 1, 0, 1, 0);

  server_name = argv[1];

  numbytes = strlen(argv[2]) + 1; // null character at end

  cerr << "Connecting..." << endl;
  while ((foo = sc->connectToServer(server_name)) != 0)
    {
      sleep(2);
    }

  if (sc->serverUsingUDP())
    {
      cerr << "Error: sctest2 only works with TCP sockets" << endl;
      exit(1);
    }

  foo = sc->current_socket->fd;

  // let's screw up the server and watch it deal
  
  numbytes = htonl(numbytes);
  slowWrite(foo, (void *) &numbytes, 4);
  numbytes = htonl(numbytes);
  slowWrite(foo, (void *) &data_type, 1);
  slowWrite(foo, (void *) argv[2], numbytes);

  sleep(1);
}
