// sctest3.c++
// Writes a megabyte to a socket.
// Tests timeout facility of server
// and recovery from these timeouts.
// Can be interrupted on server side
// to test SIGPIPE facility.
// Only works with TCP sockets.

#include <iostream.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#ifdef __GNUG__
#include "Dlist.c++"
#include "SocketMan.h"
#endif
#include "SocketClient.h"
#include "sockettests.h"

char* server_name;

int main(int argc, char **argv)
{
  int counter = 0;
  int foo;

  if (argc < 2)
    {
      cerr << "usage: sctest3 <server name>" << endl;
      exit(1);
    }
  else
    server_name = argv[1];

  SocketClient *sc = new SocketClient(port, 1, 0, 20, 0);
  global_sc = sc;
  
  cerr << "Connecting..." << endl;
  while ((foo = sc->connectToServer(server_name)) != 0)
    {
      sleep(2);
    }
  
  if (sc->serverUsingUDP())
    {
      cerr << "Error: sctest3 only works with TCP sockets" << endl;
      exit(1);
    }

  cerr << "Connected" << endl;
  // let's test with a really big buffer
  cerr << "Making SocketBuf" << endl;
  SocketBuf *sb = new SocketBuf;
  cerr << "Allocating buf" << endl;
  sb->buf = new sm_byte[1048576];
  cerr << "Testing buf" << endl;
  if (sb->buf)
    {
      int result;
      sb->type = SOCKET_CHAR;
      sb->num_bytes = 1048576;
      cerr << "Writing buf" << endl;
      result = sc->writeWithTimeout(sb);
      cerr << "Wrote buf: result = " << result << endl;
    }
  cerr << "Exiting main()" << endl;
}
