#include <math.h>
#include <Inventor/SbLinear.h>
#include <Inventor/Sb.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoDB.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/engines/SoElapsedTime.h>
#include <Inventor/engines/SoTimeCounter.h>
#include <Inventor/engines/SoInterpolate.h>
#include <Inventor/engines/SoCalculator.h>
#include <Inventor/engines/SoCompose.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoPendulum.h>
#include <Inventor/nodes/SoShuttle.h>
#include "Text.h"
#include "TextMotorSkills.h"
#include "CreatureLib.h"
#include "TextDefines.h"
#include "GenericMotorControl.h"


SO_NODE_SOURCE(Text);

void
Text::initClass()
{
    SO_NODE_INIT_CLASS(Text, MotorCreature, "MotorCreature");
}

Text::Text() : MotorCreature()
{
    SO_NODE_CONSTRUCTOR(Text);
}

SbBool
#ifdef SO_VERSION_REVISION
Text::readInstance(SoInput *in, unsigned short flags)
#else
Text::readInstance(SoInput *in)
#endif
{
#ifdef SO_VERSION_REVISION
    if (MotorCreature::readInstance(in, flags)) {
#else
    if (MotorCreature::readInstance(in)) {
#endif
	SoSearchAction sa;
	sa.setType(SoText3::getClassTypeId());
	sa.setInterest(SoSearchAction::FIRST);

	sa.apply(this);

	if (sa.getPath() == NULL) {
		fprintf(stderr, "Text Creature no Text2 node found\n");
		return(0);
	}

	TextNode = (SoText3 *)(sa.getPath()->getTail());
	return(1);
   } else {
	return(0);
   }
}


Text::~Text()
{
}

void Text::addMotorSkills()
{
    MotorCreature::addMotorSkills();

    TextSetString *str = new TextSetString(this, "setString");
    getController()->addCommand( GC_SET_STRING, "setString", str, TRUE,
				 ArgType("none"));

}

void Text::addBehaviorSystem()
{
    
}

void Text::getDOFInterpolators()
{

}

int Text::stepTo(UpdateStateData &usd)
{
    float t = usd.time;
   
    return 1;
}











