#include "slib.h"
#include <stdio.h>
#include <stdlib.h>


#include "contour.h"
#include "packet.h"

#include "contour.proto"

Contour
openContourServer(char *machine_name)
{
  int fd;

  fd = sopen(machine_name, CONTOUR_PORT);
  
  /* fails! */
  blocking(fd);
  nonLingeringSocket(fd);
  return fd;
  
}


void
getFrame(Contour con)
{
  char c = '$';
  
  sendPacket(con, (unsigned char *) &c, 1);
  
}

void
sendBacksubReset(Contour con, int thePause)
{
  char c = 'r';
  
  sendPacket(con, (unsigned char *) &c, 1);
  sleep(thePause);
}

void
sendBacksubAbort(Contour con, int thePause)
{
  char c = 'a';
  
  sendPacket(con, (unsigned char *) &c, 1);
  sleep(thePause);
}

/* returns number of valid POINTS in contour buffer part of the packet.
 */
int 
getContourPacket(Contour con, ContourPacket *cp)
{
  int numbytes;
  
  numbytes = readPacket(con, cp->bytes);
  return cp->packet.numOfPoints;
}


void
closeContourServer(Contour con)
{
  flushReadSocket(con);
  fprintf(stderr, "shutdown returned %d\n", shutdown(con,2));
  fprintf(stderr, "sclose returned %d\n", sclose(con));
}








