#include <stdio.h>
#include <getopt.h>
#include <stdlib.h>
#include <unistd.h>
#include <stropts.h>
#include "/d/vision11/aries/socketlib/slib.h"
#include "/d/vision11/aries/socketlib/contour.h"
#include "packet.h"
#include "/d/vision11/aries/socketlib/contour.proto"


static int sock;

void
  cleanup(void)
{
  sclose(sock);
  fprintf(stderr, "cleaned up\n");
  exit(1);
}

void
  main()
{
  ContourPacket mypacket;

  mypacket.packet.numOfPoints = 1.;
  mypacket.packet.centroid.x = 2.;
  mypacket.packet.centroid.y = 3.;
  mypacket.packet.bBoxMin.x = 4.;
  mypacket.packet.bBoxMin.y = 5.;
  mypacket.packet.bBoxMax.x = 6.;
  mypacket.packet.bBoxMax.y = 7.;
  mypacket.packet.head.x = 8.;
  mypacket.packet.head.y = 9.;
  mypacket.packet.hands.left.x = 10.;
  mypacket.packet.hands.left.y = 11.;
  mypacket.packet.hands.right.x = 12.;
  mypacket.packet.hands.right.y = 13.;
  mypacket.packet.feet.left.x = 14.;
  mypacket.packet.feet.left.y = 15.;
  mypacket.packet.feet.right.x = 16.;
  mypacket.packet.feet.right.y = 17.;
  mypacket.packet.contour[0] = 18.;

  fprintf(stderr, "Waiting for socket connection\n");
  sock = sserver(CONTOUR_PORT); 
  nonBlocking(sock); 
  fprintf(stderr, "Socket connection established\n"); 

  while(1)
    {
      if (dataPending(sock, 0.0)) 
	{
	  char crap;
	  readPacket(sock, (unsigned char *) &crap); /* read one byte message */
	  sendPacket(sock, mypacket.bytes, sizeof(ContourPacket));
	  sleep(1);
	  break;
	}
    }
}  
