#include <stdio.h>
#include <getopt.h>
#include <stdlib.h>
#include <unistd.h>
#include <stropts.h>
#include "/d/vision11/aries/socketlib/slib.h"
#include "/d/vision11/aries/socketlib/contour.h"
#include "packet.h"
#include "/d/vision11/aries/socketlib/contour.proto"

static int sock;

void
cleanup()
{
  closeContourServer(sock);
  fprintf(stderr, "Closed connection\n");
  exit(0);
}

void
main(int argc, char **argv)
{
  ContourPacket mypacket;
  int numberOfFloats;

  fprintf(stderr,"Acquiring connection\n");
  sock = openContourServer(argv[1]);
  fprintf(stderr,"Got socket connection\n");
  
  getFrame(sock);
  numberOfFloats = getContour(sock, (float *) mypacket.bytes);
  printf("%f\n",mypacket.packet.numOfPoints);
  printf("%f\n",mypacket.packet.centroid.x);
  printf("%f\n",mypacket.packet.centroid.y);
  printf("%f\n",mypacket.packet.bBoxMin.x);
  printf("%f\n",mypacket.packet.bBoxMin.y);
  printf("%f\n",mypacket.packet.bBoxMax.x);
  printf("%f\n",mypacket.packet.bBoxMax.y);
  printf("%f\n",mypacket.packet.head.x);
  printf("%f\n",mypacket.packet.head.y);
  printf("%f\n",mypacket.packet.hands.left.x);
  printf("%f\n",mypacket.packet.hands.left.y);
  printf("%f\n",mypacket.packet.hands.right.x);
  printf("%f\n",mypacket.packet.hands.right.y);
  printf("%f\n",mypacket.packet.feet.left.x);
  printf("%f\n",mypacket.packet.feet.left.y);
  printf("%f\n",mypacket.packet.feet.right.x);
  printf("%f\n",mypacket.packet.feet.right.y);
  printf("%f\n",mypacket.packet.contour[0]);

  cleanup();
}

  

