#ifndef __PACKET__
#define __PACKET__

#define MAX_CONTOUR_POINTS 5000
#define COORDS_PER_POINT 2
#define NUMBER_OF_EXTREMA 20
#define COORD_TYPE unsigned char
#define MAX_PACKETPOINT_VALUE ((int) (pow(2.0,(double)(8*sizeof(COORD_TYPE))) - 1.0))

typedef struct {
  COORD_TYPE x;
  COORD_TYPE y;
} packetPoint;

typedef struct {
  packetPoint left;
  packetPoint right;
} symType;

typedef struct {
  unsigned char head_status;
  unsigned char left_foot_status;
  unsigned char right_foot_status;
  unsigned char left_hand_status;
  unsigned char right_hand_status;
} bitMaskType;

typedef struct {
  packetPoint centroid;
  packetPoint bBoxMin;
  packetPoint bBoxMax;
  unsigned char numExtremities;
  COORD_TYPE extremityList[NUMBER_OF_EXTREMA * COORDS_PER_POINT];
  unsigned short numOfPoints;
  COORD_TYPE contour[MAX_CONTOUR_POINTS * COORDS_PER_POINT];
  packetPoint robotCentroid;
} ContourPacketStruct;

/* bitMaskType bitMask; 
   fPoint head; 
   symType hands;
   symType feet; */

typedef union {
  ContourPacketStruct packet;
  unsigned char bytes[sizeof(ContourPacketStruct)];
} ContourPacket;
#endif



