#ifndef _pfinder_svc_H
#define _pfinder_svc_H
#ifdef __cplusplus
extern "C" {
#endif
#define _RPCGEN_SVC
/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#include <rpc/types.h>

#define YES 1
#define NO 0

struct pfopts {
	bool_t sync;
	bool_t alive_coords;
	bool_t kalman;
	bool_t f2;
	bool_t f3;
	bool_t c2;
	bool_t c3;
	bool_t g;
};
typedef struct pfopts pfopts;
extern bool_t xdr_pfopts(XDR *, pfopts *);


struct pfv2f {
	float x;
	float y;
};
typedef struct pfv2f pfv2f;
extern bool_t xdr_pfv2f(XDR *, pfv2f *);


struct pfv3f {
	float x;
	float y;
	float z;
};
typedef struct pfv3f pfv3f;
extern bool_t xdr_pfv3f(XDR *, pfv3f *);

#define MAXCONTOURLEN 1000

struct pfgest_s {
	bool_t extend_left;
	bool_t extend_right;
	bool_t point_left;
	bool_t point_right;
	bool_t hand_moving_left;
	bool_t hand_moving_right;
	bool_t kick_left;
	bool_t kick_right;
	bool_t throw_left;
	bool_t throw_right;
	bool_t standing;
	bool_t sitting;
	bool_t bending_over;
	bool_t user_exists;
};
typedef struct pfgest_s pfgest_s;
extern bool_t xdr_pfgest_s(XDR *, pfgest_s *);


struct pffeat2d_s {
	pfv2f left_hand;
	pfv2f right_hand;
	pfv2f head;
	pfv2f centroid;
	bool_t left_hand_valid;
	bool_t right_hand_valid;
	bool_t head_valid;
	pfv2f gaze_pos;
};
typedef struct pffeat2d_s pffeat2d_s;
extern bool_t xdr_pffeat2d_s(XDR *, pffeat2d_s *);


struct pffeat3d_s {
	pfv3f left_hand;
	pfv3f right_hand;
	pfv3f head;
	pfv3f centroid;
	bool_t left_hand_valid;
	bool_t right_hand_valid;
	bool_t head_valid;
	pfv3f gaze_pos;
};
typedef struct pffeat3d_s pffeat3d_s;
extern bool_t xdr_pffeat3d_s(XDR *, pffeat3d_s *);


struct pfcont2d {
	int opt;
	union {
		struct {
			u_int points_len;
			pfv2f *points_val;
		} points;
	} pfcont2d_u;
};
typedef struct pfcont2d pfcont2d;
extern bool_t xdr_pfcont2d(XDR *, pfcont2d *);


struct pfcont3d {
	int opt;
	union {
		struct {
			u_int points_len;
			pfv3f *points_val;
		} points;
	} pfcont3d_u;
};
typedef struct pfcont3d pfcont3d;
extern bool_t xdr_pfcont3d(XDR *, pfcont3d *);


struct pfgest {
	int opt;
	union {
		pfgest_s *bits;
	} pfgest_u;
};
typedef struct pfgest pfgest;
extern bool_t xdr_pfgest(XDR *, pfgest *);


struct pffeat2d {
	int opt;
	union {
		pffeat2d_s *feats;
	} pffeat2d_u;
};
typedef struct pffeat2d pffeat2d;
extern bool_t xdr_pffeat2d(XDR *, pffeat2d *);


struct pffeat3d {
	int opt;
	union {
		pffeat3d_s *feats;
	} pffeat3d_u;
};
typedef struct pffeat3d pffeat3d;
extern bool_t xdr_pffeat3d(XDR *, pffeat3d *);


struct pfperson {
	pffeat2d f2;
	pfcont2d c2;
	pffeat3d f3;
	pfcont3d c3;
	pfgest g;
};
typedef struct pfperson pfperson;
extern bool_t xdr_pfperson(XDR *, pfperson *);


#define PFINDERPROG ((u_long)0x20000095)
#define PFINDERVERS ((u_long)1)
#define pfinit ((u_long)11)
#define pftrigger ((u_long)10)
#define pf ((u_long)12)
#define pfexit ((u_long)13)

#ifdef _RPCGEN_SVC
extern void *pfinit_1(void *, struct svc_req *);
extern void *pftrigger_1(int *, struct svc_req *);
extern pfperson *pf_1(pfopts *, struct svc_req *);
extern void *pfexit_1(void *, struct svc_req *);
#endif
#ifdef _RPCGEN_CLNT
extern void *pfinit_1(void *, CLIENT *);
extern void *pftrigger_1(int *, CLIENT *);
extern pfperson *pf_1(pfopts *, CLIENT *);
extern void *pfexit_1(void *, CLIENT *);
#endif

extern void rpc_init(void);
#undef _RPCGEN_SVC
#ifdef __cplusplus
}
#endif
#endif /* _pfinder_svc_H */
