// vtiKalmanFilter.h++
// variable time-interval Kalman filter
//
// Allows for measurements to be taken at a non-constant time interval
// Allows for a finer-grain time scale for state prediction

#ifndef _vtiKalmanFilter_H_
#define _vtiKalmanFilter_H_

#include "KalmanFilter/KalmanFilter.h++"
#include "Time/Time.h++"

class vtiKalmanFilter : public KalmanFilter
{
private:
protected:
  Time tP;
  Time tE;
  AllocVector xBase;
  AllocMatrix PBase;
  AllocMatrix dQ;
public:
  // need a more general constructor; for now just do the slick one
  vtiKalmanFilter( int ns, float rv = 1., float qv = 1., double to = -1. );
  vtiKalmanFilter& Update( QuickVector& y, Time& t, int N );
  inline vtiKalmanFilter& Update( float* fl, Time& ty, int N ) {
      return Update( QuickVector(p,fl), ty, N ); }
  virtual QuickMatrix& StateTransitionMatrix( Time& t, Time& dt );
};

#endif /* _vtiKalmanFilter_H_ */
