// QuickMath.h

#ifndef _QuickMath_H_
#define _QuickMath_H_

#include "QuickMath/QuickMatrix.h"
#include "QuickMath/QuickVector.h"
#include "QuickMath/UnitQuaternion.h"
#include "QuickMath/SubVector.h"
#include "QuickMath/SubAllocVector.h"
#include "QuickMath/SubMatrix.h"
#include "QuickMath/SubAllocMatrix.h"

class QuickMath
{
private:
public:
    static 
    QuickMatrix& 
    AddOuterProduct
    ( QuickMatrix&, QuickMatrix&, QuickVector& );

    static 
    QuickMatrix&
    SubtractOuterProduct
    ( QuickMatrix&, QuickMatrix&, QuickVector& );

    static
    QuickVector&
    Multiply
    ( QuickVector& out, QuickMatrix&, QuickVector& );

    static
    QuickVector&
    TransposeMultiply
    ( QuickVector& out, QuickMatrix&, QuickVector& );

    static
    QuickVector&
    MatrixMultiplyVector
    ( QuickVector& out, QuickMatrix& m, QuickVector& v )
    { return Multiply( out, m, v ); }

    static
    int
    eigenSymmetric2
    ( QuickVector& eValOut, QuickMatrix& eVecOut, QuickMatrix& sym2x2Mat );

    static
    QuickVector& 
    eigenSymmetric
    ( QuickVector& eValOut, QuickMatrix& eVecOut, QuickMatrix& symMat );
    
};

typedef QuickMath qm;

#endif /* _QuickMath_H_ */
