// Time.h++

#ifndef _Time_H_
#define _Time_H_

#include <sys/time.h>

class Time
{
private:
  struct timeval tv;
  double tsec;
public:
  Time() 
    : tsec( Get() ) {}
  Time( double d ) 
    : tsec( d ) {}
  Time( const Time& t ) 
    : tsec( t.tsec ) {}
  operator double() { return tsec; }
  operator struct timeval() { return TimeVal(); }
  struct timeval TimeVal() { tv.tv_sec = tsec; 
			     tv.tv_usec = (tsec - tv.tv_sec)*1.e6;
			     return tv; }
  ostream& Print( ostream& os ) { TimeVal(); 
				  return( os << tv.tv_sec << " sec, "
					  << tv.tv_usec << " usec" ); }
  double Get() { gettimeofday( &tv ); return( tv.tv_sec + tv.tv_usec/1.e6 ); }
  double Set() { return( tsec = Get() ); }
  Time& operator/=( int N ) { tsec /= N; return *this; }
  Time& operator+=( Time& t ) { tsec += t.tsec; return *this; }
  Time& operator-=( Time& t ) { tsec -= t.tsec; return *this; }
  
};

#endif /* _Time_H_ */
