/* bsColor.h */

/* RCS: $Header: /mas/vision/projects/pfinder/RCS/bsColor.h,v 6.4 1995/09/23 21:40:46 cwren Exp $ */

#ifndef _bsColor_H_
#define _bsColor_H_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "matrix.h"
#include "iveBitmap.h"
#include "iveImage.h"

typedef double ftype;		/* make sure these 4 lines  */
#define bsEXP exp		/* are consistent!!!!!!!!!! */
#define bsLOG log		/* they should be: */
#define bsSQRT sqrt		/* ftype FUNC(ftype) */
/* #define bsABS abs */		/* ftype FUNC(ftype) */ 
#define bsABS fabs

#define diff2(b,c,r) (r)[0]=(b)[0]-(c)[0];(r)[1]=(b)[1]-(c)[1];
#define diff3(b,c,r) (r)[0]=(b)[0]-(c)[0];(r)[1]=(b)[1]-(c)[1];(r)[2]=(b)[2]-(c)[2];

#define diag_transpose_dot_mat2(c,k,n) ((c)[(n)]*(k)[(n)][(n)])
#define diag_transpose_dot_mat3(c,k,n) ((c)[(n)]*(k)[(n)][(n)])

#define diag_transpose_mul_mat2(c,k,r) \
  r[0]=diag_transpose_dot_mat2(c,k,0);\
  r[1]=diag_transpose_dot_mat2(c,k,1);
#define diag_transpose_mul_mat3(c,k,r) \
  r[0]=diag_transpose_dot_mat3(c,k,0);\
  r[1]=diag_transpose_dot_mat3(c,k,1);\
  r[2]=diag_transpose_dot_mat3(c,k,2);

#define transpose_dot_mat2(c,k,n) ((c)[0]*(k)[(n)][0]+(c)[1]*(k)[(n)][1])
#define transpose_dot_mat3(c,k,n) ((c)[0]*(k)[(n)][0]+(c)[1]*(k)[(n)][1]+(c)[2]*(k)[(n)][2])

#define transpose_mul_mat2(c,k,r) \
  r[0]=transpose_dot_mat2(c,k,0);\
  r[1]=transpose_dot_mat2(c,k,1);
#define transpose_mul_mat3(c,k,r) \
  r[0]=transpose_dot_mat3(c,k,0);\
  r[1]=transpose_dot_mat3(c,k,1);\
  r[2]=transpose_dot_mat3(c,k,2);

#define dot2(b,c) ((b)[0]*(c)[0] + (b)[1]*(c)[1])
#define dot3(b,c) ((b)[0]*(c)[0] + (b)[1]*(c)[1] + (b)[2]*(c)[2])


typedef struct fg_class_s {
  /* foreground only */ 
  ftype xy_mean[2];	/* screen xy */
  Matrix xy_inv_covar;	
  ftype xy_ln_det_covar;
  ftype bb[2];
  float xyL[2];			/* eigen values */
  float xyS[2][2];		/* eigen vectors */

  /* foreground accumulators */ 
  ftype mean_acc[3];	
  Matrix covar_acc;
  ftype norm_mean_acc[3];
  Matrix norm_covar_acc;
  ftype xy_mean_acc[3];
  Matrix xy_covar_acc;

  /* prior weights */ 
  float xympriorweight;
  float xyvpriorweight;
  float cmpriorweight;
  float cvpriorweight;

  /* color/xy weights */ 
  float cxyweight;

  /* priors */
  ftype prior_mean[3];		
  Matrix prior_inv_covar;
  ftype prior_ln_det_covar;
  ftype prior_norm_mean[2];	
  Matrix prior_norm_inv_covar;
  ftype prior_norm_ln_det_covar;
  ftype prior_xy_mean[2];	
  ftype prior_xy_ln_det_covar;
  Matrix prior_xy_inv_covar;
  ftype prior_bb[2];

  /* foreground flags */
  int prior_set;
  int prior_singular;
  int num_points;
  int last_num_points;

} fg_class;

typedef struct color_class_s {
  /* used by both fg and bg */
  int singular;
  int fgp;

  ftype mean[3];		/* 3d color */
  Matrix inv_covar;
  ftype ln_det_covar;
  
  ftype norm_mean[2];		/* 2d color */
  Matrix norm_inv_covar;
  ftype norm_ln_det_covar;

  /* foreground only */ 
  fg_class *fg;

} color_class;

#define pvec3(color) printf("{%f, %f, %f}\n", (color)[0], (color)[1], (color)[2]);
#define pvec2(color) printf("{%f, %f}\n", (color)[0], (color)[1]);
#define pmat(mat) printMatrix(mat);

typedef enum  { NO_NORMALIZE=0, ALL_NORMALIZE, BG_NORMALIZE } pfNormTypes;

typedef enum  { pfFLESH, pfGREEN, pfRED, pfBROWN, pfZERO, pfGREY} pfColors;

typedef enum  { XYTINY=0, XYNARROW, XYMEDIUM, XYWIDE } pfXYCovarTypes;

#include "bsColor.proto"

#endif /* _bsColor_H_ */
