#include <stream.h>
#include <rpc/rpc.h>
#include <string.h>
#include <bstring.h>
#include <unistd.h>

#include "pfinder_clnt.h"

void main (int argc, char ** argv) {
	CLIENT *cl;
	pfperson *p;
	pfopts o;
	bzero(&o,sizeof(pfopts));
	if (argc<2) exit(0);

	if (!( cl = clnt_create( argv[1], PFINDERPROG, PFINDERVERS, "tcp")))
	  clnt_pcreateerror( argv[1] ), exit(1);


	if (argc>2) {
		o.kalman = atoi(argv[2]);
		printf(" kalman is %d\n", o.sync);
	}

	if (argc>3) {
		int t = atoi(argv[3]);
		printf(" trgger is %d\n", t);
		pftrigger_1(&t, cl);
	}

	o.f3 = o.f2 = YES;
	p = pf_1(&o, cl);
	if (!p) clnt_perror(cl, argv[1]), exit(-1);
	if (p->f3.opt) {
		pffeat3d_s *feats = p->f3.pffeat3d_u.feats;
		printf("p f3 opt %d head %g %g %g g %g %g %g %f %f %d\n", p->f3.opt, 
		       feats->head.x,feats->head.y,feats->head.z,
		       feats->gaze_pos.x,feats->gaze_pos.y,feats->gaze_pos.z,
		       feats->normal_size.x, feats->normal_size.y, feats->normal_valid);
	} else {
		printf("no f3\n");
	}
	if (p->f2.opt) {
		pffeat2d_s *feats = p->f2.pffeat2d_u.feats;
		printf("p f2 opt %d head %g %g\n", p->f2.opt, 
		       feats->head.x,feats->head.y);
	} else {
		printf("no f2\n");
	}
	sleep(1);
}

