/* iveBitmap.h */

#ifndef _IVEBITMAP_H_
#define _IVEBITMAP_H_

#include <stdio.h>

typedef struct
{
  int height;
  int width;
  int byteCount;
  unsigned char *data;
} iveBitmap;

#define iveBitmapBit( bm, y, x ) \
   iveBitmapGetBit( bm, y, x )

extern iveBitmap *iveBitmapMake( int height, int width );
extern iveBitmap *iveBitmapMakeLoad( char *file );
extern int iveBitmapGetBit( iveBitmap *bm, int y, int x );
extern void iveBitmapPutBit( iveBitmap *bm, int y, int x, int val );
extern void iveBitmapSetBit( iveBitmap *bm, int y, int x );
extern void iveBitmapUnSetBit( iveBitmap *bm, int y, int x );
extern void iveBitmapZero( iveBitmap *bm );
extern void iveBitmapWriteImage( iveBitmap *bm, FILE *stream );

#include "iveBitmap.proto"

#endif /* _IVEBITMAP_H_ */
