#include <stream.h>
#include <rpc/rpc.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/prctl.h>
#include <signal.h>
#include <sys/time.h>
#include <unistd.h>
#include <limits.h>
#include <bstring.h>

#include "pfinder_svc.h"

#define MAXREQ 10

struct svc_req REQUESTS[MAXREQ];
struct pfopts OPTS[MAXREQ];
int SYNCH=0;
int UPDATING_CONTOUR=0;
int REQ_ARR_LOCK=0;
int num_requests=0;

void cache_pf_request(pfopts *opts, struct svc_req *req) {
	while (REQ_ARR_LOCK) sginap(CLK_TCK/100+1);
	if (num_requests == MAXREQ-1) {
		fputs("threaded req buf overflow!\n",stderr);
	} else {
#ifdef DEBUG_RPC_CACHE
		fprintf(stderr,"caching req %d : %d %d \n",num_requests,
			opts->sync, opts->g);
#endif
		bcopy(opts,OPTS + num_requests,sizeof(pfopts));
		bcopy(req,REQUESTS + num_requests,sizeof(svc_req));
		num_requests++;
	}
}


void call_cached_pf_reqests(void) {
	
  REQ_ARR_LOCK=1;SYNCH=1;
  while (num_requests) {
	  num_requests--;
	  pfopts *popt = OPTS + num_requests;
	  struct svc_req *preq = REQUESTS + num_requests;
#ifdef DEBUG_RPC_CACHE
	  fprintf(stderr,"execing req %d : %d %d\n",num_requests,popt->sync,popt->g);
#endif

	  popt->sync = 0;
#ifdef DEBUG_RPC_CACHE
	  fprintf(stderr,"calling req %d : %d %d\n",num_requests,popt->sync,popt->g);
#endif
	  // while (UPDATING_CONTOUR) sginap(CLK_TCK/100+1);
	  pfperson *r = pf_1(popt,preq);
	  if (svc_sendreply(preq->rq_xprt,  (xdrproc_t) xdr_pfperson, r)) {
		  svcerr_systemerr(preq->rq_xprt);
	  }
  }
  REQ_ARR_LOCK=0;SYNCH=0;
}


